
#ifndef _ATOM_LIB_H_
#define _ATOM_LIB_H_
#include	<windows>
#include	<stdio>

//==========================================================
//		ėp֐											
//==========================================================
// Qbg
get_figure(int num, int radix=10){
	int i=1;
	while(num=num/radix) i++;
	return i;
}
// pJ^Ji
is_hankaku(char *s){
	unsigned char c = s[0];
	if ( c>=0xa1 && c<=0xdf)	return 1;
	return 0;
}

// SpiVtgJISj
is_zenkaku(char *s){
	unsigned char c = s[0];
	if ( (c>=0x81 && c<=0x9f) || (c>=0xe0 && c<=0xfc)){	// Sp̑PoCg
		c=s[1];
		if (c>=0x40 && c<=0xfc) return 1;	// Sp̑QoCg
		else return -1;
	}
	return 0;
}
// lւ
swap(int *num1, int *num2){
	int tmp=*num1;
	*num1=*num2;
	*num2=tmp;
	return 0;
}
// 啶ɂ
to_upper(char *s, int len=-1){
	int i;
	if (len<0) len=strlen(s);
	for(i=0;i<len;i++){
		if (s[i]>='a' && s[i]<='z') s[i]+='A'-'a';
	}
}

//==========================================================
//		STR													
//==========================================================
class STR {
	public:
	char *buf;
	int len;
	STR(){
		len=0;
		buf=NULL;
	}
	operator ==(char* a_buf);
	operator !=(char* a_buf);

	//  A
	fix(char *a_buf);
	operator +=(char* a_buf);
	operator +=(int num);
	operator +=(STR &a_str);

	//  
	cpy(char *a_buf);
	operator =(char* a_buf);
	operator =(int num);
	operator =(STR &a_str);
	operator char*() { return buf; }
	~STR(){ del(); }
	del();
	resize(int n=-1);
};
STR::del(){
	if (buf) delete[] buf;
	buf=NULL;
	return len=0;
}
STR::resize(int n){
	char *old_buf=buf;

	if (n<=0){
		if (buf) n=strlen(buf);
		else return del();
	}

	buf = new char[n+1];	// TCY
	memset(buf, 0, n+1);	buf[n]='\0';
	len=n;

	if (old_buf) {
		memcpy(buf, old_buf, n);
		delete[] old_buf;
	}
	return len;
}

//  A
STR::fix(char *a_buf){
	if (!a_buf) return 0;
	if (!buf) { cpy(a_buf); return 0; }
	int new_len=strlen(buf)+strlen(a_buf);
	if (new_len>len) resize(new_len);
	strcat(buf, a_buf);
	return len;
};
STR::operator +=(char* a_buf){	return fix(a_buf);};
STR::operator +=(STR &a_str){	return fix(a_str.buf); };
STR::operator +=(int num){
	char s[30];
	sprintf(s, "%d", num);
	fix(s);
	return len;
};

//  
STR::cpy(char *a_buf){
	if (!a_buf) { del(); return 0; }
	int new_len=strlen(a_buf);
	if (new_len==0) { del(); return 0; }
	if (new_len>len){
		if (buf) delete[] buf;
		len = new_len;
		buf = new char[len+1];
	}
	strcpy(buf, a_buf);
	return len;
};
STR::operator =(STR &a_str){	return cpy(a_str.buf); };
STR::operator =(char* a_buf){	return cpy(a_buf); };
STR::operator =(int num){
	char s[30];
	sprintf(s, "%d", num);
	cpy(s);
	return len;
};
//  r
STR::operator ==(char* a_buf){
	int a_len=(a_buf)? strlen(a_buf) : 0;
	if (a_buf && buf) return (!strcmp(a_buf, buf));
	else if (a_len==0 && len==a_len) return 1;
	return 0;
}
STR::operator !=(char* a_buf){
	return !(*this == a_buf);
}
//==================================================
//		POS											
//==================================================
class POS : public POINT{
	public:
	POS(){
		x=y=0;
	}
	set(int ax, int ay){ x=ax; y=ay; return 0;}
	operator RECT() {
		RECT rc;
		rc.left=x;		rc.right=0;
		rc.top=y;		rc.bottom=0;
		return rc;
	}
};
//==============================================
//		SZ										
//==============================================
class SZ : public SIZE{
	public:
	SZ(){
		cx=cy=0;
	}
	set(int w, int h){ cx=w; cy=h; return 0;}
	operator RECT() {
		RECT rc;
		rc.left=0;		rc.right=cx;
		rc.top=0;		rc.bottom=cy;
		return rc;
	}
};

//==========================================================
//		POSZ												
//==========================================================
class POSZ : public POINT, public SIZE{
	public:
	POSZ();
	set_pos(int ax, int ay);
	set_size(int aw, int ah);
	set(int ax, int ay, int aw, int ah);
	set_rel(int ax, int ay, int aw, int ah);
	POSZ(int ax, int ay, int aw, int ah);
	operator ==(POSZ sr) { return ((sr.x==x) && (sr.y==y) && (sr.cx==cx) && (sr.cy==cy)); }
	operator !=(POSZ sr) { return (!(*this ==sr)); }
	operator =(RECT rc){
		x=rc.left;		cx=rc.right-x;
		y=rc.top;		cy=rc.bottom-y;
		return 0;
	}
	operator RECT() {
		RECT rc;
		rc.left=x;		rc.right=x+cx;
		rc.top=y;		rc.bottom=y+cy;
		return rc;
	}
	rx(); ry();
};

POSZ::POSZ(){ x=y=cx=cy=0; }
POSZ::POSZ(int ax, int ay, int aw, int ah){ x=ax; y=ay; cx=aw; cy=ah; }
POSZ::rx(){ return (x+cx); }
POSZ::ry(){ return (y+cy); }
POSZ::set_pos(int ax, int ay){
	x=ax; y=ay;
	return 0;
}
POSZ::set_size(int aw, int ah){
	cx=aw; cy=ah;
	return 0;
}

POSZ::set(int ax, int ay, int aw, int ah){
	x = ax;		y = ay;
	cx = aw;	cy = ah;
	return 0;
}
POSZ::set_rel(int ax, int ay, int aw, int ah){
	x  += ax;	y  += ay;
	cx += aw;	cy += ah;
	return 0;
}

//=========nwindowsėp֐====================================
// Ps̍
get_font_height(HWND hwnd, HFONT hfont){
	HDC hdc = GetDC(hwnd);
	SelectObject(hdc, hfont);
	TEXTMETRIC tm;
	GetTextMetrics(hdc, &tm);
	ReleaseDC(hwnd, hdc);
	return tm.tmHeight;
}
/*

// Ps̍
get_font_height(HWND hwnd, HFONT hfont){
	HDC hdc = GetDC(hwnd);
	SelectObject(hdc, hfont);
	SIZE size;
	GetTextExtentPoint32(hdc, "M", 1, &size);
	ReleaseDC(hwnd, hdc);
	return size.cy;
}
*/
// Ps̍
get_font_height(HDC hdc){
	SIZE size;
	GetTextExtentPoint32(hdc, "M", 1, &size);
	return size.cy;
}
// `掞̃TCY擾		
SIZE get_str_size(HDC hdc, char* a_str){
	SIZE size, tmp_size, base_size;
	GetTextExtentPoint32(hdc, "M", 1, &base_size);
	size.cx=size.cy=0;
	if (!a_str) return size;
	int i, now_s_pos=0, len=strlen(a_str);	// len+1 ̓k̂ƂTCYm
	for(i=0;i<len;i++) {
		if (a_str[i]!='\n') continue;	// sR[hȊO͖
		GetTextExtentPoint32(hdc, a_str+now_s_pos, i-now_s_pos, &tmp_size);
		if (size.cx<tmp_size.cx) size.cx=tmp_size.cx;
		if (tmp_size.cy>0) size.cy+=tmp_size.cy;	else size.cy+=base_size.cy;
		now_s_pos=i+1;
	}
	GetTextExtentPoint32(hdc, a_str+now_s_pos, len-now_s_pos, &tmp_size);	// k
	if (size.cx<tmp_size.cx) size.cx=tmp_size.cx;
	size.cy+=tmp_size.cy;
	return size;
};
SIZE get_str_size(HWND hwnd, char* a_str){
	HDC hdc = GetDC(hwnd);
	SIZE size=get_str_size(hdc, a_str);
	ReleaseDC(hwnd, hdc);
	return size;
}

// t@CPsǂݍ
read_oneline(FILE *fp, STR *pstr){
	int i, read_index, get_index, len, c;
	if (!pstr) return 0;
	get_index=ftell(fp);		// strcpypCfbNX		
	for(len=0;;len++){			// sR[h܂ł̒߂		
		c=fgetc(fp);			// fgetcferror^̎EOFԂ	
		if (c=='\r') { c=fgetc(fp); }	//							
		if (c==EOF || c=='\n') break;	//							
	}									//							
	read_index=ftell(fp);		// ݂̓ǂݍ݈ʒuێ			
	fseek(fp , get_index , SEEK_SET);		//				

	if (pstr->len>0) pstr->buf[0]='\0';
	if (pstr->len<len) pstr->resize(len);	// ETCY
	if (len>0){
		for(i=0;i<len;i++) pstr->buf[i]=fgetc(fp);	// VKsɃRs[
		pstr->buf[len]='\0';
	}
	fseek(fp, read_index, SEEK_SET);
	return 0;
}
// 񕪊
divide_str(char *src, char punct, STR *res1, STR *res2){
	if (!res1) return 0;
	int i, len=strlen(src) ;
	for(i=0;i<len;i++){
		if (src[i]==punct) break;
	}
	res1->resize(i+2);
	strncpy(res1->buf, src, i);
	(*res1)[i]='\0';
	if (res2) *res2=src+i+1;
	return 0;
}
//=========`nwindowsėp֐====================================
draw_line(HDC hdc, int sx, int sy, int ex, int ey){
	MoveToEx(hdc, sx, sy, NULL);
	LineTo(hdc, ex, ey);
	return 0;
}

//==========================================================
//		_CAO											
//==========================================================
dialog(HWND hwnd, char *a_str=NULL, int style=0){
	int res=0, len=SendMessage(hwnd , WM_GETTEXTLENGTH, 0 , 0);
	char *buf=NULL, *str;
	static use=0;

	if (!style) style=MB_OK;
	if (len>0){
		buf=new char[len+1];
		buf[0]='\0';
		SendMessage(hwnd , WM_GETTEXT, len+1, (LPARAM)buf);
	}
	if (!use){
		use=1;
		str=a_str;
		if (!a_str)	str=TEXT("error");
		res = MessageBox(hwnd, str, buf, style);
		use=0;
	}
	if (buf) delete[] buf;
	return res;
}
inline dialog(char *str=NULL){
	return dialog(NULL, str);
}

inline dialog(int num){
	char s[20];
	sprintf(s, "%d", num);
	return dialog(s);
}
inline dialog(int num, int num2){
	char s[20];
	sprintf(s, "%d, %d", num, num2);
	return dialog(s);
}
inline dialog(int num, int num2, int num3){
	char s[20];
	sprintf(s, "%d, %d, %d", num, num2, num3);
	return dialog(s);
}
inline dialog(int num, int num2, int num3, int num4){
	char s[20];
	sprintf(s, "%d, %d, %d, %d", num, num2, num3, num4);
	return dialog(s);
}
//==========================================================
//		t@C											
//==========================================================
/*
	OS			LN^	R[h\L	16i\L	10i\L
	UNIX		\n			<LF>		0A			10
	Windows		\r\n		<CR><LF>	0D 0A		13 10
	Macintosh	\r			<CR>		0D			13
*/
read_one_line_length(FILE *fp, int *p_end_pos){
	int i, c, start_pos;
	start_pos = ftell(fp);
	for(i=0;;i++){
		c = fgetc(fp);
		if (c==EOF) break;
		if (c=='\n') break;		// UNIX
		if (c=='\r') {			// Windows or Mac
			c = fgetc(fp);
			if (c==EOF) break;
			if (c=='\n') break;	// Windows
			else {
				fseek(fp, -1, SEEK_CUR);
				break;	// Mac
			}
		}
	}

	if (p_end_pos) *p_end_pos = ftell(fp);
	fseek(fp, start_pos, SEEK_SET);
	return i;

}
// Psǂݍ
read_one_line(FILE *fp, char **pp_buf){
	int len, end_pos;
	if (feof(fp)) return -1;
	len = read_one_line_length(fp, &end_pos);
	if (!len) return -1;
	*pp_buf = new char [len+1];
	fread(*pp_buf, 1, len, fp);
	fseek(fp, end_pos, SEEK_SET);

	(*pp_buf)[len] = '\0';
	return 0;
}
// Psǂݍ
read_one_line(FILE *fp, char *buf, int buf_size){
	int len, end_pos;
	if (feof(fp)) return -1;
	len = read_one_line_length(fp, &end_pos);
	if (!len) return -2;
	if (len>buf_size) return -3;
	fread(buf, 1, len, fp);
	fseek(fp, end_pos, SEEK_SET);

	buf[len] = '\0';
	return 0;
}
// Psǂݍ݃XLbv
read_skip_one_line(FILE *fp){
	int len, end_pos;
	if (feof(fp)) return -1;
	len = read_one_line_length(fp, &end_pos);
	fseek(fp, end_pos, SEEK_SET);

	return 0;
}
//==========================================================
//		{^											
//==========================================================
HWND make_button(HWND parent, char *caption, int x, int y, int cx, int cy, int id){
	return CreateWindow(
			TEXT("BUTTON"), caption, WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
			x, y, cx, cy, parent, (HMENU)id, GetModuleHandle(NULL), NULL
		);
}
HWND make_static(HWND parent, char *caption, int x, int y, int cx, int cy){
	return CreateWindow(
			TEXT("STATIC"), caption, WS_CHILD | WS_VISIBLE,
			x, y, cx, cy, parent, (HMENU)0, GetModuleHandle(NULL), NULL
		);
}
#endif	// _ATOM_LIB_H_

