
#include "file_list_maker.h"

// JX^FillRectiCCj
inline void fill_rect(HDC hdc, int x, int y, int cx, int cy, HBRUSH hbr){
	RECT rc;
	rc.left = x;
	rc.top = y;
	rc.right = x + cx;
	rc.bottom = y + cy;
	FillRect(hdc, &rc, hbr);
}

// =========Xg\EBhENX================
// Xg\EBhENXERXgN^
CHILD_LIST_WIN::CHILD_LIST_WIN(){
	m_hwnd=NULL;
	m_now_find_path=NULL;
	m_gfont.set_size(14);
	m_p_estab = NULL;
	m_sel_folder=NULL;
	m_accumulation_count = 0;
	m_folder_accumulation_count = 0;
	m_file_accumulation_count = 0;
	m_change_filename_type = 0;

	m_hbmp_plus  = LoadBitmap(GetModuleHandle(NULL), TEXT("PLUS_BMP"));
	m_hbmp_minus = LoadBitmap(GetModuleHandle(NULL), TEXT("MINUS_BMP"));
	m_hbmp_sel_plus  = LoadBitmap(GetModuleHandle(NULL), TEXT("SEL_PLUS_BMP"));
	m_hbmp_sel_minus = LoadBitmap(GetModuleHandle(NULL), TEXT("SEL_MINUS_BMP"));
}
// \[g
CHILD_LIST_WIN::sort(int id){
	insert_sort(id);
	// quick_sort();
};
// \[gptH_r
CHILD_LIST_WIN::compare_folder(int id, FOLDER_INFO_DATA *p_folder_1, FOLDER_INFO_DATA *p_folder_2){
	switch(id){
	case IDE_FILENAME:
		return strcmp(p_folder_1->m_foldername, p_folder_2->m_foldername);
	case IDE_FILESIZE:
		break;
	case IDE_FILEATT:
		break;
	case IDE_FILEACCESSTIME:
		break;
	case IDE_FILEWRITETIME:
		break;
	case IDE_FILECREATETIME:
		break;
	}
	return 0;
}
// \[gpt@Cr
CHILD_LIST_WIN::compare_file(int id, FILE_INFO_DATA *p_file_1, FILE_INFO_DATA *p_file_2){
	int res;
	DWORD d1, d2;
	switch(id){
	// t@CŃ\[g
	case IDE_FILENAME:
		return strcmp(p_file_1->m_filename, p_file_2->m_filename);
	// t@CTCYŃ\[g
	case IDE_FILESIZE:
		res = (p_file_1->get_file_size()<p_file_2->get_file_size())? -1 : 0;
		return (!res && p_file_1->get_file_size()>p_file_2->get_file_size())? 1 : res;
	// t@CŃ\[g
	case IDE_FILEATT:
		return strcmp(p_file_1->m_filetype, p_file_2->m_filetype);
	// t@CANZXŃ\[g
	case IDE_FILEACCESSTIME:
		return CompareFileTime(&p_file_1->m_last_access_time, &p_file_2->m_last_access_time);
	// t@CXVŃ\[g
	case IDE_FILEWRITETIME:
		return CompareFileTime(&p_file_1->m_last_write_time, &p_file_2->m_last_write_time);
	// t@CŃ\[g
	case IDE_FILECREATETIME:
		return CompareFileTime(&p_file_1->m_creation_time, &p_file_2->m_creation_time);
	}
	return 0;
}

// }\[g
CHILD_LIST_WIN::insert_sort(int id){
	insert_sort_inline(id, &m_list_pack.m_top);
}
// }\[gECC
CHILD_LIST_WIN::insert_sort_inline(int id, FOLDER_INFO_DATA *p_folder){
	int target_i, insert_i, insert_pos, res;

	for(target_i=1;target_i<p_folder->m_sub_folder_list.size();target_i++){
		insert_pos = target_i;
		for(insert_i=target_i-1;insert_i>=0;insert_i--){
			res = compare_folder(id, p_folder->m_sub_folder_list[target_i], p_folder->m_sub_folder_list[insert_i]);
			if (res<0) insert_pos = insert_i;
		}
		if (insert_pos<target_i) p_folder->m_sub_folder_list.roll(target_i, insert_pos);
	}
	for(target_i=1;target_i<p_folder->m_sub_file_list.size();target_i++){
		insert_pos = target_i;
		for(insert_i=target_i-1;insert_i>=0;insert_i--){
			res = compare_file(id, p_folder->m_sub_file_list[target_i], p_folder->m_sub_file_list[insert_i]);
			if (res<0) insert_pos = insert_i;
		}
		if (insert_pos<target_i) p_folder->m_sub_file_list.roll(target_i, insert_pos);
	}

	// TufBNg
	for(target_i=0;target_i<p_folder->m_sub_folder_list.size();target_i++){
		insert_sort_inline(id, p_folder->m_sub_folder_list[target_i]);
	}
}

// XgAbvł_CAOER[obNEX^eBbN
BOOL CALLBACK CHILD_LIST_WIN::StaticNowListtingDlgProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp) {
	CHILD_LIST_WIN *pwin = (CHILD_LIST_WIN*)GetWindowLong(hwnd, GWL_USERDATA);
	if (!pwin && (msg==WM_INITDIALOG)){
		pwin = (CHILD_LIST_WIN*)lp;
		SetWindowLong(hwnd, GWL_USERDATA, (LONG)pwin);
	}
	if (msg==WM_CLOSE) {
		EndDialog(hwnd, IDCANCEL);
		return TRUE;
	}
	if (pwin) return pwin->NowListtingDlgProc(hwnd, msg, wp, lp);
	return FALSE;
}
// XgAbvł_CAOER[obN
BOOL CALLBACK CHILD_LIST_WIN::NowListtingDlgProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp) {
	HDC hdc;
	TEXTMETRIC tm;
	PAINTSTRUCT pt;
	char s[100];

	switch (msg) {
	case WM_CLOSE:
		end_timer_list_up();
		EndDialog(hwnd, IDCANCEL);
		return TRUE;
	case WM_TIMER:
		switch(wp) {
		case IDT_CALL_LIST_UP_INLINE:
			m_count_at_once = 0;
			next_timer_list_up();
			break;
		}
		InvalidateRect(hwnd, NULL, TRUE);
		return TRUE;
	case WM_COMMAND:
		switch(LOWORD(wp)){
		case IDCANCEL:
			end_timer_list_up();
			EndDialog(hwnd, IDCANCEL);
			return TRUE;
		};
		return TRUE;
	case WM_PAINT:
		hdc = BeginPaint(hwnd, &pt);
		SetBkMode(hdc, TRANSPARENT);
	//	SelectObject(hdc, m_gfont.m_hfont);
		GetTextMetrics(hdc, &tm);
		sprintf(s, "Xg : %d", m_accumulation_count);
		TextOut(hdc, 20, 30, s, strlen(s));
		EndPaint(hwnd, &pt);
		return TRUE;
	case WM_INITDIALOG:
		m_hdlg_nowlistting = hwnd;
		SetTimer(m_hdlg_nowlistting, IDT_CALL_LIST_UP_INLINE, 100, NULL);
		return TRUE;
	}
	return FALSE;
}

// óEEEHTMLwb_
void CHILD_LIST_WIN::output_html_head(FILE *fp){
	char *ps;
	ps = "\n<html>\n<head>\n<meta http-equiv=\"content-type\" content=\"text/html; charset=Shift_JIS\">\n"
		"<title></title>\n</head>\n<body>\n";
	fwrite(ps, 1, strlen(ps), fp);

	ps = "<table cellpadding=\"2\" cellspacing=\"2\" border=\"1\"\n style=\"text-align: left; \">\n"
			"<tbody>\n<tr>\n<td style=\"vertical-align: top;\">";
	fwrite(ps, 1, strlen(ps), fp);
}
// óEEEHTMLtb^
void CHILD_LIST_WIN::output_html_tail(FILE *fp){
	char *ps;
	ps = "</tbody>\n</table>\n<br>\n</body>\n</html>\n";
}
// óEEECfg
inline void CHILD_LIST_WIN::output_indent(FILE *fp, int indent){
	char *ps;
	int cm_i;

	switch(m_output_work_filetype){
	case IDE_FILETYPE_CSV: ps = ","; break;
	case IDE_FILETYPE_HTM:
		ps = "<tr>"; fwrite(ps, 1, strlen(ps), fp);
		ps = "<td></td>";
		break;
	case IDE_FILETYPE_TXT: ps = "\t"; break;
	case IDE_FILETYPE_ALL: ps = ","; break;
	}
	for(cm_i=0;cm_i<indent;cm_i++) fwrite(ps, 1, strlen(ps), fp);
}
// óEEEs
inline void CHILD_LIST_WIN::output_new_line(FILE *fp){
	char *ps;

	switch(m_output_work_filetype){
	case IDE_FILETYPE_CSV: ps = "\n"; break;
	case IDE_FILETYPE_HTM: ps = "</tr>\n"; break;
	case IDE_FILETYPE_TXT: ps = "\n"; break;
	case IDE_FILETYPE_ALL: ps = "\n"; break;
	}
	fwrite(ps, 1, strlen(ps), fp);
}
// óEEEACe̍ڐ擪
inline void CHILD_LIST_WIN::output_eachitem_head(FILE *fp, int colspan){
	char *ps;

	switch(m_output_work_filetype){
	case IDE_FILETYPE_CSV: ps = ""; break;
	case IDE_FILETYPE_HTM: ps = (colspan)? "<td colspan=2>" : "<td>"; break;
	case IDE_FILETYPE_TXT: ps = ""; break;
	case IDE_FILETYPE_ALL: ps = ""; break;
	}
	fwrite(ps, 1, strlen(ps), fp);
}
// óEEEACe̍ڌ㕔
inline void CHILD_LIST_WIN::output_eachitem_tail(FILE *fp){
	char *ps;

	switch(m_output_work_filetype){
	case IDE_FILETYPE_CSV: ps = ","; break;
	case IDE_FILETYPE_HTM: ps = "</td>"; break;
	case IDE_FILETYPE_TXT: ps = ","; break;
	case IDE_FILETYPE_ALL: ps = ","; break;
	}
	fwrite(ps, 1, strlen(ps), fp);
}
// o̓CC
CHILD_LIST_WIN::output_list_inline(FILE *fp, FOLDER_INFO_DATA *p_folder, int depth){
	char *ps;
	int i, cm_i, ci, filesize;
	char s[100];

	for(i=0;i<p_folder->m_sub_folder_list.size();i++){
	//	for(cm_i=0;cm_i<depth;cm_i++) fwrite(&comma, 1, 1, fp);
		output_indent(fp, depth);

		for(ci=0;ci<m_header_cc.get_column_len();ci++){
			output_eachitem_head(fp, 0);
			switch(m_p_estab->m_item_order[ci]){
			case IDE_FILENAME:
				ps=p_folder->m_sub_folder_list[i]->m_foldername;
				if (ps) fwrite(ps, 1, strlen(ps), fp);
				break;
			case IDE_FILESIZE:
				break;
			case IDE_FILEATT:
			case IDE_FILEWRITETIME:
			case IDE_FILEACCESSTIME:
			case IDE_FILECREATETIME:
				break;
			}
		//	fwrite(&comma, 1, 1, fp);
			output_eachitem_tail(fp);
		}

	//	fwrite(&nl, 1, 1, fp);	// s
		output_new_line(fp);
		output_list_inline(fp, p_folder->m_sub_folder_list[i], depth+1);
	}
	for(i=0;i<p_folder->m_sub_file_list.size();i++){
	//	for(cm_i=0;cm_i<depth;cm_i++) fwrite(&comma, 1, 1, fp);
		output_indent(fp, depth);

		for(ci=0;ci<m_header_cc.get_column_len();ci++){
			output_eachitem_head(fp, 0);
			switch(m_p_estab->m_item_order[ci]){
			case IDE_FILENAME:
				ps=p_folder->m_sub_file_list[i]->m_filename;
				if (ps) fwrite(ps, 1, strlen(ps), fp);
				break;
			case IDE_FILESIZE:
				filesize = p_folder->m_sub_file_list[i]->get_file_size();
				sprintf(s, "%d KB", filesize/1024+((filesize%1024)>0));
				if (s) fwrite(s, 1, strlen(s), fp);
				break;
			case IDE_FILEATT:
				ps=p_folder->m_sub_file_list[i]->m_filetype;
				if (ps) fwrite(ps, 1, strlen(ps), fp);
				break;
			case IDE_FILEWRITETIME:
				get_time_str(s, &p_folder->m_sub_file_list[i]->m_last_write_time);
				if (s) fwrite(s, 1, strlen(s), fp);
				break;
			case IDE_FILEACCESSTIME:
				get_time_str(s, &p_folder->m_sub_file_list[i]->m_last_access_time);
				if (s) fwrite(s, 1, strlen(s), fp);
				break;
			case IDE_FILECREATETIME:
				get_time_str(s, &p_folder->m_sub_file_list[i]->m_creation_time);
				if (s) fwrite(s, 1, strlen(s), fp);
				break;
			}
		//	fwrite(&comma, 1, 1, fp);
			output_eachitem_tail(fp);
		}

	//	fwrite(&nl, 1, 1, fp);
		output_new_line(fp);
	}
}
// o
CHILD_LIST_WIN::output_list(){
//	if (!m_p_estab) return -1;
	OPENFILENAME ofn = {0};
	char filename[MAX_PATH], *ps;
	memset(filename, 0, MAX_PATH);
	ofn.lStructSize = OPENFILENAME_SIZE_VERSION_400;	// sizeof (OPENFILENAME);
	ofn.hwndOwner = m_hwnd;
	ofn.lpstrFilter = TEXT("Csv files {*.csv}\0*.csv\0")
			 	TEXT("HTML files {*.html}\0*.html\0")
			 	TEXT("Text files {*.txt}\0*.txt\0")
				TEXT("All files {*.*}\0*.*\0\0");
	ofn.lpstrFile = filename;
	ofn.nMaxFile = MAX_PATH;
	ofn.Flags = 0;
	if (!GetSaveFileName(&ofn)) return 0;

	char *aim_ext1, *aim_ext2, *ext=NULL;
	switch(ofn.nFilterIndex){
	case 1:	m_output_work_filetype = IDE_FILETYPE_CSV; aim_ext1= ".csv";  aim_ext2= ".xls"; break;
	case 2:	m_output_work_filetype = IDE_FILETYPE_HTM; aim_ext1= ".html"; aim_ext2= ".htm"; break;
	case 3:	m_output_work_filetype = IDE_FILETYPE_TXT; aim_ext1= ".txt";  aim_ext2= ""; break;
	case 4:
	default: m_output_work_filetype = IDE_FILETYPE_ALL; aim_ext1= NULL; break;
	}

	int i, ci;
	for(i=strlen(filename)-1;i>0;i--){
		if (filename[i]=='.') { ext=filename+i; break; }
	}
	if (!ext || ((aim_ext1 && strcmp(ext, aim_ext1))
		 && (aim_ext2 && strcmp(ext, aim_ext2)) )	) {
		strcat(filename, aim_ext1);
	}

	FILE *fp;
	fp=fopen(filename, "wb");
	if (!fp) {
		char s[512];
		sprintf(s, "G[Ft@CJ܂\n[%s]", filename);
		dialog(m_hwnd, s);
		return -1;
	}
	if (m_output_work_filetype == IDE_FILETYPE_HTM) output_html_head(fp);

	for(ci=0;ci<m_header_cc.get_column_len();ci++){
		output_eachitem_head(fp, 0);
		switch(m_p_estab->m_item_order[ci]){
		case IDE_FILENAME		: ps = "t@C";	break;
		case IDE_FILESIZE		: ps = "t@CTCY";	break;
		case IDE_FILEATT		: ps = "";break;
		case IDE_FILEACCESSTIME : ps = "ŏIANZX";	break;
		case IDE_FILEWRITETIME	: ps = "XV";	break;
		case IDE_FILECREATETIME	: ps = "쐬";	break;
		};
		if (ps) fwrite(ps, 1, strlen(ps), fp);
		output_eachitem_tail(fp);
	}
	output_new_line(fp);

	output_list_inline(fp, &m_list_pack.m_top, 0);
	if (m_output_work_filetype == IDE_FILETYPE_HTM) output_html_tail(fp);
	fclose(fp);
};
CHILD_LIST_WIN::set_now_find_path(char *path){
		int len = strlen(path);
		m_now_find_path = new char[len+1];
		strcpy(m_now_find_path, path);
}
CHILD_LIST_WIN::set_list_pack(char *path){
//	m_list_pack.list_up(path);
	renew_size();
	m_vscroll.set_pos(0);

	m_list_pack.m_top.set_path(path);
	start_timer_list_up();
}

// Xg
CHILD_LIST_WIN::clear_list(){
	m_list_pack.m_top.m_sub_folder_list.del_all();
	m_list_pack.m_top.m_sub_file_list.del_all();
}
// ^C}[XgAbvJn
CHILD_LIST_WIN::start_timer_list_up(){
	clear_list();

	m_find_path_stack.del_all();

	m_find_path_stack.a_push();
	m_find_path_stack.last()->set(NULL, m_list_pack.m_top.m_foldername, &m_list_pack.m_top);

	m_count_at_once = 0;
	m_accumulation_count = 0;
	m_folder_accumulation_count=0;
	m_file_accumulation_count=0;
	DialogBoxParam(
		(HINSTANCE)GetWindowLong(m_hwnd, GWL_HINSTANCE),
		TEXT("IDD_NOW_LISTTING_UP"), m_hwnd, StaticNowListtingDlgProc, (LPARAM)this
	);
}
// ^C}[XgAbvI
CHILD_LIST_WIN::end_timer_list_up(){
	if (IsWindow(m_hdlg_nowlistting)) KillTimer(m_hdlg_nowlistting, IDT_CALL_LIST_UP_INLINE);
	renew_size();
	m_vscroll.set_pos(0);

	if (IsWindow(m_hdlg_nowlistting)) {
		EndDialog(m_hdlg_nowlistting, IDOK);
	}

	set_cursor(GetParent(m_hwnd), IDC_ARROW);
	set_cursor(m_hwnd, IDC_ARROW);
	EnableWindow(GetParent(m_hwnd), TRUE);

	InvalidateRect(GetParent(m_hwnd), NULL, TRUE);
	InvalidateRect(m_header_cc.m_hwnd, NULL, TRUE);
}

// ^C}[XgAbvI_CAOĂяo
CHILD_LIST_WIN::list_up_complete_dialog(){
	DialogBox(
		(HINSTANCE)GetWindowLong(m_hwnd, GWL_HINSTANCE),
		TEXT("IDD_LIST_UP_COMPLETE"), m_hwnd, StaticDlgProc
	);
}
// ^C}[XgAbṽCC֐
void CHILD_LIST_WIN::findnext_inline(FIND_PATH_ITEM *p_fpi, char *path){
	char sub_path[_MAX_PATH];
	FOLDER_INFO_DATA *p_folder = p_fpi->m_find_folder;
	if (!p_folder) return;

	if (!strcmp(p_fpi->m_wfd.cFileName, "..") || !strcmp(p_fpi->m_wfd.cFileName, ".")) {
		if (p_fpi->m_wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY); return;
	}

	if (p_fpi->m_wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY){
		p_folder->add_sub_folder(p_fpi->m_wfd.cFileName, path);
		sprintf(sub_path, "%s\\%s", path, p_fpi->m_wfd.cFileName);
		m_folder_accumulation_count++;	// 

		if (!m_p_estab || (m_p_estab && m_p_estab->m_find_sub_folder)){
			m_find_path_stack.a_push();
			m_find_path_stack.last()->set(NULL, sub_path, p_folder->m_sub_folder_list.last());
			next_timer_list_up();
		}
	}
	else {
		if (m_p_estab && m_p_estab->m_find_folder_only) return;
		p_folder->add_file(&p_fpi->m_wfd, path);
		m_file_accumulation_count++;
	}
	m_accumulation_count++;	// ݐσJE^

}
// ^C}[XgAbv
void CHILD_LIST_WIN::next_timer_list_up(){
	char path[_MAX_PATH];
	if (!m_find_path_stack.last()) {
		end_timer_list_up();
		list_up_complete_dialog();
		return;
	}
	FIND_PATH_ITEM *p_fpi = m_find_path_stack.last();
	strcpy(path, p_fpi->m_path);

	char find_path[_MAX_PATH];

	sprintf(find_path, "%s\\*", path);

	if (!p_fpi->m_hfind) {
		p_fpi->m_hfind=FindFirstFile(find_path, &p_fpi->m_wfd);
		// G[
		if (p_fpi->m_hfind==INVALID_HANDLE_VALUE) {
			m_find_path_stack.pop();
			return;
		}
		findnext_inline(p_fpi, path);
	}

	HANDLE *p_hfind = &p_fpi->m_hfind;

	// G[
	if (*p_hfind==INVALID_HANDLE_VALUE) {
		m_find_path_stack.pop();
		return;
	}

	while (FindNextFile(*p_hfind, &p_fpi->m_wfd)) {
		findnext_inline(p_fpi, path);
		m_count_at_once++;
		if (m_count_at_once>100) return;
	}
	 
	FindClose(*p_hfind);
	m_find_path_stack.pop();
	if (IsWindow(m_hdlg_nowlistting)) {
		InvalidateRect(m_hdlg_nowlistting, NULL, TRUE);
		Sleep(0);
		UpdateWindow(m_hdlg_nowlistting);
	}
};
/*
void CHILD_LIST_WIN::next_timer_list_up(){
	char path[_MAX_PATH];
	FOLDER_INFO_DATA *p_folder=NULL;
	if (!m_find_path_stack.last()) {
		end_timer_list_up();
		return;
	}
	strcpy(path, m_find_path_stack.last()->m_path);
	p_folder = m_find_path_stack.last()->m_find_folder;
	m_find_path_stack.pop();

	WIN32_FIND_DATA wfd;
	char find_path[_MAX_PATH];
	char sub_path[_MAX_PATH];
	if (!p_folder) return;

	sprintf(find_path, "%s\\*", path);

	HANDLE hfind = FindFirstFile(find_path, &wfd);
	if (hfind==INVALID_HANDLE_VALUE) return;

	do{
		if (!strcmp(wfd.cFileName, "..") || !strcmp(wfd.cFileName, ".")) {
			if (wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY); continue;
		}

		if (wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY){
			p_folder->add_sub_folder(wfd.cFileName, path);
			sprintf(sub_path, "%s\\%s", path, wfd.cFileName);
		//	list_up_inline(sub_path, p_folder->m_sub_folder_list.last());
			m_find_path_stack.a_push();
			m_find_path_stack.last()->set(NULL, sub_path, p_folder->m_sub_folder_list.last());
		}
		else {
			p_folder->add_file(wfd.cFileName);
		}
	}while (FindNextFile(hfind, &wfd));
 
	FindClose(hfind);
};
*/
// Xg\EBhENXETCYXV
void CHILD_LIST_WIN::renew_size(){
	RECT rc;
	GetClientRect(m_hwnd, &rc);
	int back_cx, back_cy;
	if (m_winx!=rc.right || m_winy!=rc.bottom){
		back_cx=rc.right;
		back_cy=rc.bottom;
		if (back_cx<200) back_cx=200;
		if (back_cy<200) back_cy=200;
		if (back_cx!=m_back_dib.m_width || back_cy!=m_back_dib.m_height) {
			m_back_dib.create(back_cx, back_cy, 24);
			m_back_dib.fill(0,0, back_cx, back_cy, 255,255,255);
			m_back_dib.apply_dc(m_hwnd);
		}
	}
	m_winx=rc.right;
	m_winy=rc.bottom;
	int n;
	n = m_list_pack.m_top.get_show_list_size();

	m_vscroll.set_range(0, n+2, rc.bottom/14);

	renew_size_horz();
	
}
// Xg\EBhENXETCYXVij
void CHILD_LIST_WIN::renew_size_horz(){
	int ww, i;
	ww=0;
	for(i=0;i<m_header_cc.get_column_len();i++){
		ww += m_header_cc.get_column_width(i);
	}
	ww+=10;
	SetWindowPos(m_header_cc.m_hwnd, NULL, 0, 0, (ww>(m_winx))? (ww+20):m_winx+5, 20, SWP_NOMOVE);
	m_hscroll.set_range(0, ww/5+1, m_winx/5);
}
// Xg\EBhENXE}EXʒuԍ擾
CHILD_LIST_WIN::get_num_by_pos(POINT po, FOLDER_INFO_DATA **res_pp_folder, int &type, int &num){
	int target, font_height;
	target = m_vscroll.get_pos();

	font_height = get_font_height(m_hwnd, m_gfont.m_hfont);
	if (font_height>0) target += (po.y-20)/font_height;

	target++;	// m_top

	get_num_by_pos_inline(res_pp_folder, &m_list_pack.m_top, target, type, num);
};
// Xg\EBhENXE}EXʒuԍ擾CC
CHILD_LIST_WIN::get_num_by_pos_inline(
		FOLDER_INFO_DATA **res_pp_folder, FOLDER_INFO_DATA *p_folder, int &target, int &type, int &num){
	
	if (target==0) {
		type = IDE_FOLDER;
		num = 0;
		*res_pp_folder = p_folder;
		return 1;
	}

	int i, len;
	if (!p_folder->m_show_sub_dir_flag) return 0;

	// TufBNg
	len = p_folder->m_sub_folder_list.size();
	for(i=0;i<len;i++){
		target--;	// tH_g̕
		if (get_num_by_pos_inline(res_pp_folder, p_folder->m_sub_folder_list[i], target, type, num))
			return 1;	// m
	}

	len = p_folder->m_sub_file_list.size();
	if (target>len) target -= len;
	else {
		// m
		*res_pp_folder = p_folder;
		type = IDE_FILE;
		num = target-1;
		return 1;
	}
	return 0;
};

// Xg\EBhENXE}EX_E
CHILD_LIST_WIN::on_lbuttondown(){
	POINT po;
	RECT rc;
	GetCursorPos(&po);
	GetWindowRect(m_hwnd, &rc);
	po.x -= rc.left;
	po.y -= rc.top;

	FOLDER_INFO_DATA *p_folder;
	int type, num;
	get_num_by_pos(po, &p_folder, type, num);
	int co = p_folder->m_show_sub_dir_icon_co;
	if (type == IDE_FOLDER && p_folder && co<po.x && (po.x<co+14)){
		p_folder->m_show_sub_dir_flag = !p_folder->m_show_sub_dir_flag;
		renew_size();
	}
	else {
		m_sel_folder = p_folder;
		m_sel_type	= type;
		m_sel_num	= num;
	}
	InvalidateRect(m_hwnd, NULL, TRUE);
};
// Xg\EBhENXEE}EX_E
CHILD_LIST_WIN::on_rbuttondown(){
	HMENU hmenu, hmenu_sub;

	hmenu = LoadMenu(GetModuleHandle(NULL), TEXT("LIST_WIN_R_MENU"));
	hmenu_sub = GetSubMenu(hmenu, 0);

	POINT po;
	GetCursorPos(&po);
	TrackPopupMenu(hmenu_sub, TPM_LEFTALIGN | TPM_TOPALIGN, po.x, po.y, 0, m_hwnd, NULL);

	DestroyMenu(hmenu_sub);
	DestroyMenu(hmenu);
}

// Xg\EBhENXER[obNstatic
LRESULT CALLBACK CHILD_LIST_WIN::StaticChildListWndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp) {
	CHILD_LIST_WIN *pwin = (CHILD_LIST_WIN*)GetWindowLong(hwnd, GWL_USERDATA);
	if (!pwin && (msg==WM_NCCREATE || msg==WM_CREATE)){
		pwin = (CHILD_LIST_WIN*)((LPCREATESTRUCT)lp)->lpCreateParams;
		SetWindowLong(hwnd, GWL_USERDATA, (LONG)pwin);
	}
	if (pwin) return pwin->ChildListWndProc(hwnd, msg, wp, lp);
	return DefWindowProc(hwnd, msg, wp, lp);
}

// O̕ύX_CAOStatic
BOOL CALLBACK CHILD_LIST_WIN::StaticChangeNameProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp) {
	CHILD_LIST_WIN *pwin = (CHILD_LIST_WIN*)GetWindowLong(hwnd, GWL_USERDATA);
	if (!pwin && (msg==WM_INITDIALOG)){
		pwin = (CHILD_LIST_WIN*)lp;
		SetWindowLong(hwnd, GWL_USERDATA, (LONG)pwin);
	}
	if (pwin) return pwin->ChangeNameProc(hwnd, msg, wp, lp);
	switch (msg) {
	case WM_CLOSE:
		EndDialog(hwnd, IDOK);
		return TRUE;
	}
	return FALSE;
}

// O̕ύX_CAO Ăяo
CHILD_LIST_WIN::call_change_filename(HWND hedit){
	char dir[1024], f2[MAX_PATH], *f1;
	if (!m_sel_folder) return 0;
	GetWindowText(hedit, f2, MAX_PATH);

	if (m_sel_type==IDE_FILE){
		m_sel_folder->m_sub_file_list[m_sel_num]->m_parent_folder->get_fullpath(dir, 1024);
		f1 = m_sel_folder->m_sub_file_list[m_sel_num]->m_filename;
	}
	else if (m_sel_type==IDE_FOLDER){
		m_sel_folder->get_fullpath(dir, 1024);
		f1 = strrchr(dir, '\\');
		f1[0]=NULL;
		f1 = m_sel_folder->m_foldername;
	}

	if (m_change_filename_type==IDC_CHANGE_FILENAME)
			change_filename(m_hwnd, dir, f1, f2);

	if (m_sel_type==IDE_FILE) m_sel_folder->m_sub_file_list[m_sel_num]->set_name(f2);
	else if (m_sel_type==IDE_FOLDER) m_sel_folder->set_path(f2);
}
// O̕ύX_CAO
BOOL CALLBACK CHILD_LIST_WIN::ChangeNameProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp) {
	char *ps;
	switch (msg) {
	case WM_CLOSE:
		EndDialog(hwnd, IDCANCEL);
		return TRUE;
	case WM_COMMAND:
		switch (LOWORD(wp)) {
		case IDOK:
			call_change_filename(GetDlgItem(hwnd, IDC_NEW_FILENAME_EDIT));
			EndDialog(hwnd, IDOK);
			return TRUE;
		case IDCANCEL:
			EndDialog(hwnd, IDCANCEL);
			return TRUE;
		}
		return TRUE;
	case WM_INITDIALOG:
		if (!m_sel_folder) EndDialog(hwnd, IDOK);
		ps = NULL;
		if (m_sel_type==IDE_FILE) ps = m_sel_folder->m_sub_file_list[m_sel_num]->m_filename;
		else if (m_sel_type==IDE_FOLDER) ps = m_sel_folder->m_foldername;

		if (ps == NULL) EndDialog(hwnd, IDOK);

		SetWindowText(GetDlgItem(hwnd, IDC_OLD_FILENAME_EDIT), ps);
		return TRUE;
	}
	return FALSE;
}

// Xg\EBhENXER}h
CHILD_LIST_WIN::on_command(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp){
	char s[1024];
	switch (LOWORD(wp)) {
	case IDC_OPEN_PARENT_FOLDER:
		if (!m_sel_folder) break;
		if (m_sel_type==IDE_FILE){
			m_sel_folder->get_fullpath(s, 1024);
		}
		else if (m_sel_type==IDE_FOLDER){
			m_sel_folder->m_parent->get_fullpath(s, 1024);
		}
		else break;
		// etH_J
		open_file(m_hwnd, s);
		break;
	// t@CJȂ
	case IDC_OPEN_FILE:
	case IDC_CALL_FILE_PROPERTY:
	case IDC_REMOVE_FILE:
		if (!m_sel_folder) break;
		if (m_sel_type==IDE_FILE){
			m_sel_folder->m_sub_file_list[m_sel_num]->get_fullpath(s, 1024);
		}
		else if (m_sel_type==IDE_FOLDER){
			m_sel_folder->get_fullpath(s, 1024);
		}
		else break;
		Sleep(0);

		// J
		if (LOWORD(wp)==IDC_OPEN_FILE) open_file(m_hwnd, s);

		// vpeBĂяo
		if (LOWORD(wp)==IDC_CALL_FILE_PROPERTY) {
			call_property_seet(m_hwnd, s);
		}
		// ۂ̃t@C폜
		if (LOWORD(wp)==IDC_REMOVE_FILE) {
			remove_file(m_hwnd, s);
			m_sel_folder->m_sub_file_list.pop(m_sel_num);
			InvalidateRect(hwnd, NULL, TRUE);			
		}
		// Xg폜邾
		if (LOWORD(wp)==IDC_REMOVE_FILE_LISTONLY) {
			m_sel_folder->m_sub_file_list.pop(m_sel_num);
			InvalidateRect(hwnd, NULL, TRUE);			
		}
		break;
	// t@CύX
	case IDC_CHANGE_FILENAME_LISTONLY:
	case IDC_CHANGE_FILENAME:
		if (!m_sel_folder) break;
		m_change_filename_type = LOWORD(wp);
		if (IDOK==DialogBoxParam(
					(HINSTANCE)GetWindowLong(hwnd, GWL_HINSTANCE),
					TEXT("IDD_CHANGE_FILENAME"), hwnd, StaticChangeNameProc, (LPARAM)this
				)) InvalidateRect(hwnd, NULL, TRUE);
		break;
	};
}

// Xg\EBhENXER[obN
LRESULT CALLBACK CHILD_LIST_WIN::ChildListWndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp) {
	switch (msg) {
	// EBhEj[
	case WM_COMMAND:
		on_command(hwnd, msg, wp, lp);
		break;
	// EBhEj
	case WM_DESTROY:
		break;
	// }EXzC[
	case WM_MOUSEWHEEL:
		m_vscroll.on_mousewheel(wp, lp);
		InvalidateRect(hwnd, NULL, TRUE);
		break;
	// XN[o[
	case WM_VSCROLL:
		m_vscroll.on_scroll(wp, lp);
		InvalidateRect(hwnd, NULL, TRUE);
		break;
	// XN[o[
	case WM_HSCROLL:
		m_hscroll.on_scroll(wp, lp);
		SetWindowPos(m_header_cc.m_hwnd, NULL, -m_hscroll.get_pos()*5, 0, 0, 0, SWP_NOSIZE);
		InvalidateRect(hwnd, NULL, TRUE);
		break;
	// EBhE
	case WM_CREATE:
		m_vscroll.make(hwnd, 'v');
		m_hscroll.make(hwnd, 'h');
		break;
	// EBhE`
	case WM_PAINT:
		on_paint();
		break;
	// EBhETCYύX
	case WM_SIZE:
		renew_size();
		break;
	// E}EX_E
	case WM_RBUTTONDOWN:
		SetFocus(hwnd);
		on_rbuttondown();
	//	dialog(ai, a[0], a[ai-2], a[ai-1]);
		break;
	// }EX_E
	case WM_LBUTTONDOWN:
		SetFocus(hwnd);
		on_lbuttondown();
		break;
	// NOTIFY
	case WM_NOTIFY:
		LPNMHEADER pnm = (LPNMHEADER)lp;
		NMHDR *lpnmhdr = (NMHDR *)lp;
		if (!lp) break;
		if (lp && lpnmhdr->hwndFrom != m_header_cc.m_hwnd) break;
		switch(pnm->hdr.code){
		case HDN_TRACK:
			if (!m_header_cc.is_dragging()) m_header_cc.start_drag(hwnd);
			else m_header_cc.on_drag();
			break;
		case HDN_ENDTRACK:
			m_header_cc.end_drag();
		//	a[ai]=4;ai++;
		//	pnm->iItem		// Rԍ
		//	pnm->pitem->cxy	// fBoC_݈ʒu
		//	return TRUE;
		//	return FALSE;	// 
			m_header_cc.set_column_width(pnm->iItem, pnm->pitem->cxy);
			renew_size_horz();
			InvalidateRect(m_hwnd, NULL, TRUE);
			break;
		case HDN_ITEMCLICK:
			sort(m_p_estab->m_item_order[pnm->iItem]);
			// pnm->pitem==NULL
			InvalidateRect(m_hwnd, NULL, TRUE);
			break;
		}
		break;
	}
	return DefWindowProc(hwnd, msg, wp, lp);
}

// Xg`
void CHILD_LIST_WIN::on_paint(){
	HDC hdc;
	TEXTMETRIC tm;
	PAINTSTRUCT pt;
	int i, x, clen;
	RECT rc;

	hdc = m_back_dib.m_hdc;
	m_back_dib.fill(0,0,m_back_dib.m_width, m_back_dib.m_height, 255,255,255);

	m_dc_work_hdc_plus_bmp = CreateCompatibleDC(hdc);
	m_dc_work_hdc_minus_bmp = CreateCompatibleDC(hdc);
	m_dc_work_hdc_sel_plus_bmp = CreateCompatibleDC(hdc);
	m_dc_work_hdc_sel_minus_bmp = CreateCompatibleDC(hdc);
	SelectObject(m_dc_work_hdc_plus_bmp,  m_hbmp_plus);
	SelectObject(m_dc_work_hdc_minus_bmp, m_hbmp_minus);
	SelectObject(m_dc_work_hdc_sel_plus_bmp,  m_hbmp_sel_plus);
	SelectObject(m_dc_work_hdc_sel_minus_bmp, m_hbmp_sel_minus);


	SelectObject(hdc, m_gfont.m_hfont);
	GetTextMetrics(hdc, &tm);
	m_dc_work_font_height = tm.tmHeight;
	x=-m_hscroll.get_pos()*5;
	m_dc_work_co_x[0] = -m_hscroll.get_pos()*5;
	for(i=0;i<m_header_cc.get_column_len();i++){
		x += m_header_cc.get_column_width(i);
		m_dc_work_co_x[i+1] = x;
	}
	draw_list_inline(&m_back_dib, 0, 0, &m_list_pack.m_top, m_vscroll.get_pos());

	GetClientRect(m_hwnd, &rc);
	HBRUSH hbr_white = (HBRUSH)GetStockObject(WHITE_BRUSH);
	x = m_dc_work_co_x[m_header_cc.get_column_len()];
	fill_rect(hdc, x, 20, rc.right-x, rc.bottom-20, hbr_white);

	DeleteDC(m_dc_work_hdc_plus_bmp);
	DeleteDC(m_dc_work_hdc_minus_bmp);
	DeleteDC(m_dc_work_hdc_sel_plus_bmp);
	DeleteDC(m_dc_work_hdc_sel_minus_bmp);

	// 摜]
	hdc = BeginPaint(m_hwnd, &pt);
	BitBlt(hdc, 0, 20, rc.right, rc.bottom, m_back_dib.m_hdc, 0, 0, SRCCOPY);
	EndPaint(m_hwnd, &pt);

}

// Xg`CC****************************************
CHILD_LIST_WIN::draw_list_inline(GT_DIB *p_dib, int name_x, int &y, FOLDER_INFO_DATA* p_folder, int &start_num){
	int li, ci, tmp_len, tmp_x;
	HDC hdc = p_dib->m_hdc;
	GT_IMG *p_icon;
	UINT filesize;
	HDC hdc_icon;
	char *ps, s[100];
	HBRUSH hbr_white = (HBRUSH)GetStockObject(WHITE_BRUSH);
	HBRUSH hbr_sel = GetSysColorBrush(COLOR_HIGHLIGHT);
	tmp_len=p_folder->get_list_size();
	if (tmp_len<start_num){
		start_num -= tmp_len;
		return 0;
	}
	for(li=0;li<p_folder->m_sub_folder_list.size();li++){
		if (start_num>0) {
			start_num--;
		}
		else {
			for(ci=0;ci<m_header_cc.get_column_len();ci++){
				if (m_sel_type == IDE_FOLDER && (p_folder->m_sub_folder_list[li])==m_sel_folder){
					fill_rect(hdc, m_dc_work_co_x[ci], y,
						m_dc_work_co_x[ci+1]-m_dc_work_co_x[ci], m_dc_work_font_height, hbr_sel);
						SetBkColor(hdc, GetSysColor(COLOR_HIGHLIGHT));
						SetTextColor(hdc, GetSysColor(COLOR_HIGHLIGHTTEXT));
				}
				else {
					fill_rect(hdc, m_dc_work_co_x[ci], y,
						m_dc_work_co_x[ci+1]-m_dc_work_co_x[ci], m_dc_work_font_height, hbr_white);
						SetBkColor(hdc, RGB(255,255,255));
						SetTextColor(hdc, RGB(0,0,0));
				}
				switch(m_p_estab->m_item_order[ci]){
				case IDE_FILENAME:
					tmp_x = m_dc_work_co_x[ci]+name_x;
					p_folder->m_sub_folder_list[li]->m_show_sub_dir_icon_co = tmp_x;	// ACR`ʒuێ

					if (m_sel_type == IDE_FOLDER && (p_folder->m_sub_folder_list[li])==m_sel_folder){
						if (p_folder->m_sub_folder_list[li]->m_show_sub_dir_flag)
								hdc_icon = m_dc_work_hdc_sel_minus_bmp;
						else 	hdc_icon = m_dc_work_hdc_sel_plus_bmp;
						BitBlt(hdc, tmp_x, y, 14, 14, hdc_icon, 0, 0, SRCPAINT);
					}
					else {
						if (p_folder->m_sub_folder_list[li]->m_show_sub_dir_flag)
								hdc_icon = m_dc_work_hdc_minus_bmp;
						else 	hdc_icon = m_dc_work_hdc_plus_bmp;
						BitBlt(hdc, tmp_x, y, 14, 14, hdc_icon, 0, 0, SRCAND);
					}
					tmp_x += 14;

					p_icon = &p_folder->m_sub_folder_list[li]->m_icon_img;
					if (p_icon) {
						p_dib->from_draw(tmp_x, y, 14, 14, p_icon, 0, 0);
						tmp_x += 16;
					}

					ps=p_folder->m_sub_folder_list[li]->m_foldername;
					if (ps) TextOut(hdc, tmp_x, y, ps, lstrlen(ps));
					break;
				case IDE_FILESIZE:
				//	sprintf(s, "%d KB", p_folder->m_sub_folder_list[li]->get_file_size()/1024);
				//	if (s) TextOut(hdc, m_dc_work_co_x[i], y, s, lstrlen(s));
					break;
				case IDE_FILEATT:
					ps = "tH_";
					if (ps) TextOut(hdc, m_dc_work_co_x[ci], y, ps, lstrlen(ps));
					break;
				case IDE_FILEWRITETIME:
				case IDE_FILEACCESSTIME:
				case IDE_FILECREATETIME:
					break;
				}
			}
			y += m_dc_work_font_height;
		}
		// TufBNg
		if (p_folder->m_sub_folder_list[li]->m_show_sub_dir_flag){
			tmp_x = (m_p_estab && m_p_estab->m_sub_dir_indent)? name_x+20 : name_x;
			if (draw_list_inline(p_dib, tmp_x, y, p_folder->m_sub_folder_list[li], start_num)<0) return -1;
		}
		if (y>=m_winy) return -1;
	}
	for(li=0;li<p_folder->m_sub_file_list.size();li++){
		if (start_num>0) {
			start_num--;
			continue;
		}
			for(ci=0;ci<m_header_cc.get_column_len();ci++){
				if (m_sel_type == IDE_FILE && p_folder==m_sel_folder && m_sel_num==li){
					fill_rect(hdc, m_dc_work_co_x[ci], y,
						m_dc_work_co_x[ci+1]-m_dc_work_co_x[ci], m_dc_work_font_height, hbr_sel);
					SetBkColor(hdc, GetSysColor(COLOR_HIGHLIGHT));
					SetTextColor(hdc, GetSysColor(COLOR_HIGHLIGHTTEXT));
				}
				else {
					if (ci!=0)
						fill_rect(hdc, m_dc_work_co_x[ci], y,
							m_dc_work_co_x[ci+1]-m_dc_work_co_x[ci], m_dc_work_font_height, hbr_white);
					SetBkColor(hdc, RGB(255,255,255));
					SetTextColor(hdc, RGB(0,0,0));
				}
			//		fill_rect(hdc, m_dc_work_co_x[ci], y,
			//			m_dc_work_co_x[ci+1]-m_dc_work_co_x[ci], m_dc_work_font_height, hbr_white);
				switch(m_p_estab->m_item_order[ci]){
				case IDE_FILENAME:
					tmp_x = m_dc_work_co_x[ci]+name_x;
					tmp_x += 14;	// tH_[+][-]\

					p_icon = &(p_folder->m_sub_file_list[li]->m_icon_img);
					if (p_icon) {
						p_dib->from_draw(tmp_x, y, 14, 14, p_icon, 0, 0);
						tmp_x += 16;
					}

					ps=p_folder->m_sub_file_list[li]->m_filename;
					if (ps) TextOut(hdc, tmp_x, y, ps, lstrlen(ps));

					break;
				case IDE_FILESIZE:
					filesize = p_folder->m_sub_file_list[li]->get_file_size();
					sprintf(s, "% 7d KB", filesize/1024+((filesize%1024)>0));
					if (s) TextOut(hdc, m_dc_work_co_x[ci], y, s, lstrlen(s));
					break;
				case IDE_FILEATT:
					ps = p_folder->m_sub_file_list[li]->m_filetype;
					if (ps) TextOut(hdc, m_dc_work_co_x[ci], y, ps, lstrlen(ps));
					break;
				case IDE_FILEWRITETIME:
					get_time_str(s, &p_folder->m_sub_file_list[li]->m_last_write_time);
					if (s) TextOut(hdc, m_dc_work_co_x[ci], y, s, lstrlen(s));
					break;
				case IDE_FILEACCESSTIME:
					get_time_str(s, &p_folder->m_sub_file_list[li]->m_last_access_time);
					if (s) TextOut(hdc, m_dc_work_co_x[ci], y, s, lstrlen(s));
					break;
				case IDE_FILECREATETIME:
					get_time_str(s, &p_folder->m_sub_file_list[li]->m_creation_time);
					if (s) TextOut(hdc, m_dc_work_co_x[ci], y, s, lstrlen(s));
					break;
				}
			}
	//	ps=p_folder->m_sub_file_list[i]->m_filename;
	//	if (ps) TextOut(hdc, name_x, y, ps, lstrlen(ps));
		y += m_dc_work_font_height;
		if (y>=m_winy) return -1;
	}
	return 0;
};
