
#include "file_list_maker_items.h"

// ========tH_f[^ENX============
// tpX擾
FOLDER_INFO_DATA::get_fullpath(char *s, int buf_size){
	XLIST<FOLDER_INFO_DATA*> parent_stack;
	FOLDER_INFO_DATA *parent;
	parent = this;
	while(parent) {
		parent_stack.push(parent);
		parent = parent->m_parent;
	}
	s[0]=NULL;
	int n=parent_stack.size()-1, len=0;
	while(n>=0) {
		parent = parent_stack[n];
		if (!parent) break;

		len+=strlen(parent->m_foldername)+1;	// obt@Et[`FbN
		if (len>=buf_size) return -1;

		strcat(s, parent->m_foldername);
		if (n!=0) strcat(s, "\\");
		n--;
	}
	return 0;
}
FOLDER_INFO_DATA::get_show_list_size(){
	int i,len=0;
	if (!m_show_sub_dir_flag) return 0;
	for(i=0;i<m_sub_folder_list.size();i++) len+=m_sub_folder_list[i]->get_show_list_size();
	return len+m_sub_folder_list.size()+m_sub_file_list.size();
}
FOLDER_INFO_DATA::get_list_size(){
	int i,len=0;
	for(i=0;i<m_sub_folder_list.size();i++) len+=m_sub_folder_list[i]->get_list_size();
	return len+m_sub_folder_list.size()+m_sub_file_list.size();
}

// ============t@Cf[^ENX============

// tpX擾
FILE_INFO_DATA::get_fullpath(char *s, int buf_size){
	if (m_parent_folder->get_fullpath(s, buf_size)<0) return -1;
	int len=strlen(m_filename)+2;
	if ((strlen(s)+len)>=buf_size) return -1;
	strcat(s, "\\");
	strcat(s, m_filename);
	return 0;
};

// TutH_ǉ
inline FOLDER_INFO_DATA::add_sub_folder(char *name, char *dirpath){
	FOLDER_INFO_DATA *p = m_sub_folder_list.a_push();
	p->set_path(name);
	p->m_parent = this;

	SHFILEINFO shfi;
	char s[1024];
	sprintf(s, "%s\\%s\0", dirpath, name);
	SHGetFileInfo(s, 0, &shfi, sizeof(SHFILEINFO), SHGFI_ICON | SHGFI_SMALLICON);

	// ACRݒ
	p->set_icon(shfi.hIcon);
	DestroyIcon(shfi.hIcon);
}
// t@Cǉ
inline FOLDER_INFO_DATA::add_file(WIN32_FIND_DATA *p_wfd, char *dirpath){
	FILE_INFO_DATA *p = m_sub_file_list.a_push();
	p->set_name(p_wfd->cFileName);
	p->set_size(p_wfd->nFileSizeHigh, p_wfd->nFileSizeLow);
	p->m_attributes = p_wfd->dwFileAttributes;
	p->m_creation_time = p_wfd->ftCreationTime;
	p->m_last_access_time = p_wfd->ftLastAccessTime;
	p->m_last_write_time = p_wfd->ftLastWriteTime;

	p->m_parent_folder = this;
	SHFILEINFO shfi;
	char s[1024];
	sprintf(s, "%s\\%s\0", dirpath, p_wfd->cFileName);
	SHGetFileInfo(s, 0, &shfi, sizeof(SHFILEINFO), /* SHGFI_ICON | SHGFI_SMALLICON | */ SHGFI_TYPENAME);
	strcpy(p->m_filetype, shfi.szTypeName);

/*
	// ߖ̂߃t@Cp̃ACR͕\Ȃ
	// ACRݒ
	p->set_icon(shfi.hIcon);
	DestroyIcon(shfi.hIcon);
*/
}


// ============ݒf[^========================
ESTAB_DATA::ESTAB_DATA(){
	m_find_sub_folder = 1;
	m_find_folder_only = 0;
	m_item_order_len = 2;
	m_sub_dir_indent =1;
	m_item_order[0] = IDE_FILENAME;
	m_item_order[1] = IDE_FILESIZE;

	m_dir_history_max = 10;
}
ESTAB_DATA::~ESTAB_DATA(){
	clear_dir_history();
};

ESTAB_DATA::clear_dir_history(){
	int i;
	for(i=0;i<m_dir_history.size();i++){
		delete[] (m_dir_history[i]);
	}
	m_dir_history.del_all();
};


// ===========XgNX==============================

// XgQbg
LIST_PACK::get_list_size(){
	return m_top.get_list_size();
};
// \XgQbg
LIST_PACK::get_show_list_size(){
	return m_top.get_show_list_size();
}
// XgXVCC
void LIST_PACK::list_up_inline(char *path, FOLDER_INFO_DATA *p_folder){
	WIN32_FIND_DATA wfd;
	char find_path[_MAX_PATH];
	char sub_path[_MAX_PATH];
	if (!p_folder) return;

	sprintf(find_path, "%s\\*", path);

	HANDLE hfind = FindFirstFile(find_path, &wfd);
	if (hfind==INVALID_HANDLE_VALUE) return;

	do{
		if (!strcmp(wfd.cFileName, "..") || !strcmp(wfd.cFileName, ".")) {
			if (wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY); continue;
		}

		if (wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY){
			p_folder->add_sub_folder(wfd.cFileName, path);
			sprintf(sub_path, "%s\\%s", path, wfd.cFileName);
			list_up_inline(sub_path, p_folder->m_sub_folder_list.last());
		}
		else {
			p_folder->add_file(&wfd, path);
		}
	}while (FindNextFile(hfind, &wfd));
 
	FindClose(hfind);
}
// XgXV
void LIST_PACK::list_up(char *path){
	m_top.m_sub_folder_list.del_all();
	m_top.m_sub_file_list.del_all();
	m_top.set_path(path);
	list_up_inline(path, &m_top);
}

// =========^C}FIND_PATH_ITEM============

FIND_PATH_ITEM::set(HANDLE hfind, char *path, FOLDER_INFO_DATA *find_folder){
	m_find_folder=find_folder;
	m_hfind = hfind;
	int len = strlen(path);
	m_path = new char[len+1];
	strcpy(m_path, path);
};
