
#include "gt_img.h"
#include "qlist.h"
#include "id_defines.h"

// FILETIME  
get_time_str(char *s, FILETIME *p_ftime){
	SYSTEMTIME sys_time;
	FileTimeToSystemTime(p_ftime, &sys_time);
	wsprintf(s, TEXT(" %d/%2d/%2d %2d:%2d:%2d "),
		sys_time.wYear, sys_time.wMonth, sys_time.wDay,
		sys_time.wHour, sys_time.wMinute, sys_time.wSecond
	);
}

class FILE_INFO_DATA;
// ========t@CtH_f[^ENX============
class FOLDER_FILE_INFO_DATA_BASE{
	public:
	static GT_DIB g_icon_dib;
	GT_IMG m_icon_img;
	create_g_icon_dib(){
		g_icon_dib.create(100,100,24);
		g_icon_dib.fill(0,0,100,100,255,255,255);
		g_icon_dib.apply_dc();
	}
	set_icon(HICON hicon){
		if (!g_icon_dib.m_hdc) create_g_icon_dib();
		g_icon_dib.fill(0,0,14,14,255,255,255);
		DrawIconEx(g_icon_dib.m_hdc, 0, 0, hicon, 14, 14, 0, NULL, DI_NORMAL);
		m_icon_img.create(14, 14, 24);
		m_icon_img.from_draw(0,0,14,14,&g_icon_dib,0,0);
	}
};
GT_DIB FOLDER_FILE_INFO_DATA_BASE::g_icon_dib;

// ========tH_f[^ENX============
class FOLDER_INFO_DATA : public FOLDER_FILE_INFO_DATA_BASE{
	public:
	char *m_foldername;
	double m_foldersize;
	FOLDER_INFO_DATA *m_parent;
	PLIST<FOLDER_INFO_DATA> m_sub_folder_list;
	PLIST<FILE_INFO_DATA> 	m_sub_file_list;
	inline add_file(WIN32_FIND_DATA *p_wfd, char *dirpath);
	add_sub_folder(char *name, char *dirpath);
	int m_show_sub_dir_flag;
	int m_show_sub_dir_icon_co;

	FOLDER_INFO_DATA(){
		m_foldername=NULL;
		m_show_sub_dir_flag = 1;
		m_show_sub_dir_icon_co=0;
		m_parent=NULL;
	}
	~FOLDER_INFO_DATA(){
		m_foldersize = 0;
		if (m_foldername) delete[] m_foldername;
	}
	set_path(char *s){
		int len = strlen(s);
		m_foldername = new char[len+1];
		strcpy(m_foldername, s);
	};
	get_list_size();
	get_show_list_size();
	get_fullpath(char *s, int buf_size);
	hide_sub_dir(){ return m_show_sub_dir_flag = 0; };
	show_sub_dir(){ return m_show_sub_dir_flag = 1; };
};

// ============t@Cf[^ENX============
class FILE_INFO_DATA : public FOLDER_FILE_INFO_DATA_BASE{
	public:
	char *m_filename, m_filetype[80];
	FOLDER_INFO_DATA *m_parent_folder;
	UINT m_filesize_hi, m_filesize_low;
	FILETIME m_creation_time, m_last_access_time, m_last_write_time;
	UINT m_attributes;
	get_fullpath(char *s, int buf_size);

	set_name(char *s){
		int len = strlen(s);
		m_filename = new char[len+1];
		strcpy(m_filename, s);
	};
	set_size(UINT filesize_hi, UINT filesize_low){
		m_filesize_hi  = filesize_hi;
		m_filesize_low = filesize_low;
	};
	FILE_INFO_DATA(){
		m_filename=NULL;
		m_parent_folder=NULL;
		m_filesize_hi = m_filesize_low = 0;
		m_filetype[0]=NULL;
	}
	~FILE_INFO_DATA(){
		if (m_filename) delete[] m_filename;
	}
	UINT get_file_size(){
		return (m_filesize_hi * MAXDWORD)+m_filesize_low;
	}
};
// ============ݒf[^========================
class ESTAB_DATA {
	public :
	int m_find_sub_folder, m_find_folder_only;
	int m_item_order[IDE_ITEM_ORDER_MAX];
	int m_item_order_width[IDE_ITEM_ORDER_MAX];
	int m_item_order_len;
	int m_sub_dir_indent;

	int m_dir_history_max;
	XLIST<char*> m_dir_history;	// 𕶎  char *  ̃Xg

	ESTAB_DATA();
	~ESTAB_DATA();

	clear_dir_history();
};
// ===========XgNX==============================
class LIST_PACK{
	public:
	FOLDER_INFO_DATA m_top;
	get_list_size();
	get_show_list_size();
	void list_up(char *path);
	void LIST_PACK::list_up_inline(char *path, FOLDER_INFO_DATA *p_dir);
};


// =========^C}FIND_PATH_ITEM============
class FIND_PATH_ITEM{
	public:
	int m_fi;
	char *m_path;
	FOLDER_INFO_DATA *m_find_folder;
	HANDLE m_hfind;
	WIN32_FIND_DATA m_wfd;

	FIND_PATH_ITEM(){
		m_find_folder=NULL;
		m_path=NULL;
	}
	~FIND_PATH_ITEM(){
		if (m_path) delete[] m_path;
	}
	set(HANDLE hfind, char *path, FOLDER_INFO_DATA *find_folder);
};

