
#ifndef _GOBJ_H_
#define _GOBJ_H_

#include <windows>

// ~[gsNZ	
log_to_pix(HDC hdc, int val, int vh_flag){
	if (vh_flag=='h') return val * GetDeviceCaps(hdc, HORZRES)/GetDeviceCaps(hdc, HORZSIZE);
	if (vh_flag=='v') return val * GetDeviceCaps(hdc, VERTRES)/GetDeviceCaps(hdc, VERTSIZE); // *mm/pix
	return 1;
}
// sNZ~[g	
pix_to_log(HDC hdc, int val, int vh_flag){
	if (vh_flag=='h') return val * GetDeviceCaps(hdc, HORZSIZE)/GetDeviceCaps(hdc, HORZRES);
	if (vh_flag=='v') return val * GetDeviceCaps(hdc, VERTSIZE)/GetDeviceCaps(hdc, VERTRES); // *pix/mm
	return 1;
}
get_dc_width(HDC hdc){	return GetDeviceCaps(hdc, HORZRES); }
get_dc_height(HDC hdc){	return GetDeviceCaps(hdc, VERTRES); }

//===============tHgTCYύX===================================
HFONT change_font_size_rel(HFONT hfont, int val){
	LOGFONT lf;
	if (!GetObject(hfont, sizeof(LOGFONT), &lf)){
		memset(&lf, 0, sizeof(LOGFONT));
		lf.lfCharSet = SHIFTJIS_CHARSET;
	}
	lf.lfHeight=lf.lfHeight*val;
	return CreateFontIndirect(&lf);
}
HFONT change_font_size(HFONT hfont, int val){
	LOGFONT lf;
	if (!GetObject(hfont, sizeof(LOGFONT), &lf)){
		memset(&lf, 0, sizeof(LOGFONT));
		lf.lfCharSet = SHIFTJIS_CHARSET;
	}
	lf.lfHeight=val;
	return CreateFontIndirect(&lf);
}
//===============hԂ===================================
fill(HDC hdc, int x, int y, int w, int h, COLORREF col){
	HBRUSH br;
	br=CreateSolidBrush(col);
//	HBRUSH old_br=(HBRUSH)SelectObject(hdc, br);
//	Rectangle(hdc, x, y, w, h);
	RECT rc;
	rc.top=y;
	rc.left=x;
	rc.right=x+w;
	rc.bottom=y+h;
	FillRect(hdc, &rc, br);
	SelectObject(hdc, (HBRUSH)GetStockObject(BLACK_BRUSH));
	return DeleteObject(br);
}
fill(HDC hdc, int x, int y, int w, int h, HBRUSH hbr){
	RECT rc;
	rc.top=y;
	rc.left=x;
	rc.right=x+w;
	rc.bottom=y+h;
	FillRect(hdc, &rc, hbr);
	SelectObject(hdc, (HBRUSH)GetStockObject(BLACK_BRUSH));
	return 0;
}
line_draw(HDC hdc, int sx, int sy, int ex, int ey, COLORREF col, int thick=1){
	HPEN hpen=CreatePen(PS_SOLID, thick, col);
	SelectObject(hdc, hpen);
	MoveToEx(hdc, sx, sy, NULL);
	LineTo(hdc, ex, ey);
	SelectObject(hdc, (HPEN)GetStockObject(BLACK_PEN));
	return DeleteObject(hpen);
}
line_draw(HDC hdc, int sx, int sy, int ex, int ey, HPEN hpen){
	SelectObject(hdc, hpen);
	MoveToEx(hdc, sx, sy, NULL);
	LineTo(hdc, ex, ey);
	SelectObject(hdc, (HPEN)GetStockObject(BLACK_PEN));
	return 0;
}

rim_draw(HDC hdc, int sx, int sy, int ex, int ey, COLORREF col, int thick=1){
	HPEN hpen=CreatePen(PS_SOLID, thick, col);
	SelectObject(hdc, hpen);
//	HPEN old_hpen=(HPEN)SelectObject(hdc, hpen);
	MoveToEx(hdc, sx, sy, NULL);
	LineTo(hdc, ex, sy);
	LineTo(hdc, ex, ey);
	LineTo(hdc, sx, ey);
	LineTo(hdc, sx, sy);
	SelectObject(hdc, (HPEN)GetStockObject(BLACK_PEN));
	return DeleteObject(hpen);
}
rim_draw(HDC hdc, int sx, int sy, int ex, int ey, HPEN hpen){
	SelectObject(hdc, hpen);
	MoveToEx(hdc, sx, sy, NULL);
	LineTo(hdc, ex, sy);
	LineTo(hdc, ex, ey);
	LineTo(hdc, sx, ey);
	LineTo(hdc, sx, sy);
	SelectObject(hdc, (HPEN)GetStockObject(BLACK_PEN));
	return 0;
}

//==========================================
//	GFONT									
//==========================================
class GFONT {
	public :
	HFONT m_hfont;
	set_size_rel(int val);
	set_size(int val);
	//tHgTCYύX
	GFONT(){
		m_hfont=NULL;
	}
	~GFONT(){
		DeleteObject(m_hfont);
	}
};
GFONT::set_size_rel(int val){
	LOGFONT lf;
	if (!GetObject(m_hfont, sizeof(LOGFONT), &lf)){
		memset(&lf, 0, sizeof(LOGFONT));
		lf.lfCharSet = SHIFTJIS_CHARSET;
	}
	lf.lfHeight=lf.lfHeight*val;
	DeleteObject(m_hfont);
	m_hfont=CreateFontIndirect(&lf);
	return 0;
}
GFONT::set_size(int val){
	LOGFONT lf;
	if (!GetObject(m_hfont, sizeof(LOGFONT), &lf)){
		memset(&lf, 0, sizeof(LOGFONT));
		lf.lfCharSet = SHIFTJIS_CHARSET;
	}
	lf.lfHeight=val;
	DeleteObject(m_hfont);
	m_hfont=CreateFontIndirect(&lf);
	return 0;
}

//==========================================
// 	G_CHECK_BOX							
//==========================================
class G_CHECK_BOX {
	public:
	HWND m_hwnd;
	HWND create(HWND parent, char *caption, int id, int x, int y, int cx, int cy);
	get_check();
	set_check(int f);
};
HWND G_CHECK_BOX::create(HWND parent, char *caption, int id, int x, int y, int cx, int cy){
	m_hwnd=CreateWindow(
		TEXT("BUTTON"), caption, WS_CHILD | WS_VISIBLE | BS_AUTOCHECKBOX,
		x, y, cx, cy, parent, (HMENU)id, GetModuleHandle(NULL), NULL
	);
	return m_hwnd;
};
G_CHECK_BOX::set_check(int f){
	if (f) SendMessage(m_hwnd, BM_SETCHECK, BST_CHECKED, 0);
	else SendMessage(m_hwnd, BM_SETCHECK, BST_UNCHECKED, 0);
}
G_CHECK_BOX::get_check(){
	return (BST_CHECKED == SendMessage(m_hwnd, BM_GETCHECK, BST_CHECKED, 0));
}
//==========================================
// 	G_SCROLL_BAR							
//==========================================
class G_SCROLL_BAR {
	SCROLLINFO m_scr_info;
	int m_bar_type;
	HWND m_hwnd;
	public:
	get_pos(){ return m_scr_info.nPos; }
	G_SCROLL_BAR(){
		m_bar_type=0;
		m_hwnd=NULL;
		memset(&m_scr_info, 0, sizeof(SCROLLINFO));

		m_scr_info.cbSize = sizeof(SCROLLINFO);
		m_scr_info.fMask = SIF_PAGE | SIF_RANGE;// | SIF_DISABLENOSCROLL;
		m_scr_info.nMin = m_scr_info.nMax = 0;
		m_scr_info.nPage = 1;
	}
	make(HWND a_hwnd, int vh){
		m_hwnd=a_hwnd;
		if (vh=='v') m_bar_type=SB_VERT;
		if (vh=='h') m_bar_type=SB_HORZ;
		set();
		return 0;
	}
	on_scroll(WPARAM wp , LPARAM lp);
	on_mousewheel(WPARAM wp, LPARAM lp);
	set_range(int min_val, int max_val, int page_val);
	set_pos(int pos_val);
	adjust_pos();
	set(bool flag=TRUE);
};
G_SCROLL_BAR::set(bool flag){
	if (!m_hwnd)return 0;
	return SetScrollInfo(m_hwnd, m_bar_type, &m_scr_info, flag);
}

// }EXzC[	
G_SCROLL_BAR::on_mousewheel(WPARAM wp, LPARAM lp){
	static char working=0;
	if (working || !m_hwnd)return 0;
	working=1;
	short n=(short)HIWORD(wp);
	int old_pos  = m_scr_info.nPos;
	if (n>0 && m_scr_info.nPos>(m_scr_info.nMin+1)) m_scr_info.nPos-=2;
	else if (n<0) m_scr_info.nPos+=2;
	adjust_pos();
	set();
	Sleep(10);
	working=0;
	return (old_pos != m_scr_info.nPos);
	//	Mouse_stat.fwkeys=(int)wprm; //{^
	//	Mouse_stat.xpos=(int)LOWORD(lp); //wW
	//	Mouse_stat.ypos=(int)HIWORD(lp); //xW 
}


G_SCROLL_BAR::adjust_pos(){
	int min_val=m_scr_info.nMin, max_val=m_scr_info.nMax, page_val=m_scr_info.nPage;
	if (m_scr_info.nPos > (max_val-page_val+1)) { m_scr_info.nPos=max_val-page_val+1; }
	if (m_scr_info.nPos < min_val) m_scr_info.nPos = min_val;
	m_scr_info.fMask = SIF_POS;// | SIF_DISABLENOSCROLL;
	return 0;
}
G_SCROLL_BAR::set_pos(int pos_val){
	m_scr_info.nPos=pos_val;
	adjust_pos();
	set();
	return 0;
}
// y[Wݒ	
G_SCROLL_BAR::set_range(int min_val, int max_val, int page_val){
	m_scr_info.nPage=page_val;
	m_scr_info.nMax = max_val;
	m_scr_info.nMin = min_val;
	adjust_pos();
	m_scr_info.fMask = SIF_POS | SIF_PAGE | SIF_RANGE;// | SIF_DISABLENOSCROLL;
	set();
	return 0;
}

// XN[	
G_SCROLL_BAR::on_scroll(WPARAM wp, LPARAM lp){
	if (!m_hwnd) {
		dialog("܂XN[o[̐eEBhEݒ肳ĂȂB");return 0;
	}
	int old_npos = m_scr_info.nPos;
	switch(LOWORD(wp)) {
	case SB_TOP:		m_scr_info.nPos = m_scr_info.nMin;break;
	case SB_BOTTOM:		m_scr_info.nPos = m_scr_info.nMax;break;
	case SB_LINEUP:		m_scr_info.nPos--;		break;
	case SB_LINEDOWN:	m_scr_info.nPos++;		break;
	case SB_PAGEUP:		m_scr_info.nPos -= m_scr_info.nPage;break;
	case SB_PAGEDOWN:	m_scr_info.nPos += m_scr_info.nPage;break;
	case SB_THUMBPOSITION:	m_scr_info.nPos = HIWORD(wp);break;
	case SB_THUMBTRACK:		m_scr_info.nPos = HIWORD(wp);break;
	}
	adjust_pos();
	if (old_npos == m_scr_info.nPos) return 0;
	m_scr_info.fMask = SIF_POS;// | SIF_DISABLENOSCROLL;
	set();
	return 0;
}

// wb_Rg[NX
class HEADER_CC{
	public :
	int m_now_dragging, m_owner_win_y;
	HDC m_owner_hdc;
	HWND m_hwnd, m_drag_owner;
    HRGN m_apply_rgn, m_work_rgn, m_last_rgn;    // [W

	add_column(char *str, int column_width);
	get_column_width(int column_num);
	set_column(int column_num, char* str, int column_width);
	get_column_len();
	del_column(int column_num);
	set_column_width(int column_num, int column_width);

	is_dragging();	// hbO
	start_drag(HWND drag_owner);	// hbOJn
	on_drag();		// hbO
	end_drag();		// hbOI

	HEADER_CC();
	~HEADER_CC();
};
HEADER_CC::HEADER_CC(){
	m_now_dragging = 0;
}
HEADER_CC::~HEADER_CC(){
}

// hbO
HEADER_CC::is_dragging(){
	return m_now_dragging;
}
// hbOJn
HEADER_CC::start_drag(HWND drag_owner){
	RECT rc;
	m_drag_owner = drag_owner;
	GetClientRect(m_drag_owner, &rc);
	m_owner_win_y = rc.bottom;

	m_now_dragging = 1;
	m_apply_rgn	= CreateRectRgn(0, 0, 0, 0);
	m_work_rgn	= CreateRectRgn(0, 0, 0, 0);
	m_last_rgn	= CreateRectRgn(0, 0, 0, 0);

	LockWindowUpdate(m_drag_owner);		// cbbN
	m_owner_hdc = GetDCEx(m_drag_owner, NULL, DCX_CACHE|DCX_LOCKWINDOWUPDATE);	// cb擾
}
// hbO
HEADER_CC::on_drag(){
	RECT rc;
	POINT po;
	GetCursorPos(&po);
	ScreenToClient(m_drag_owner, &po);

	SetRectRgn(m_apply_rgn,	po.x, 0, po.x+1, m_owner_win_y);
	CombineRgn(m_work_rgn, m_last_rgn, m_apply_rgn, RGN_XOR);
	SelectObject(m_owner_hdc, m_work_rgn);
	GetRgnBox(m_work_rgn, &rc);

	// ]ɂ``
	PatBlt(m_owner_hdc, rc.left, rc.top, rc.right-rc.left, rc.bottom-rc.top, PATINVERT);
	CombineRgn(m_last_rgn, m_apply_rgn, NULL, RGN_COPY);
}
// hbOI
HEADER_CC::end_drag(){
	RECT rc;
	SelectObject(m_owner_hdc, m_apply_rgn);
	PatBlt(m_owner_hdc, rc.left, rc.top, rc.right-rc.left, rc.bottom-rc.top, PATINVERT);

	DeleteObject(m_apply_rgn);
	DeleteObject(m_last_rgn);
	DeleteObject(m_work_rgn);

	LockWindowUpdate(NULL);	// cbbN
	if (m_owner_hdc) ReleaseDC(m_drag_owner, m_owner_hdc);	// cb

	m_now_dragging = 0;
}

HEADER_CC::get_column_len(){
	return SendMessage(m_hwnd, HDM_GETITEMCOUNT, 0, 0);
}
HEADER_CC::del_column(int column_num){
	SendMessage(m_hwnd, HDM_DELETEITEM, column_num, 0);
}
HEADER_CC::add_column(char *str, int column_width){
	int column_num=0;
	HDITEM hi;
	memset(&hi, 0, sizeof(HDITEM));
	hi.mask = HDI_TEXT | HDI_WIDTH | HDI_LPARAM | HDI_ORDER;
	hi.pszText = str;
	hi.cchTextMax = strlen(str);
	hi.cxy = column_width;
	hi.lParam = strlen(str);
	hi.iOrder = column_num;
	SendMessage(m_hwnd, HDM_INSERTITEM, column_num, (LPARAM)&hi);
}
HEADER_CC::get_column_width(int column_num){
	HDITEM hi;
	memset(&hi, 0, sizeof(HDITEM));
	hi.mask = HDI_WIDTH;
	SendMessage(m_hwnd, HDM_GETITEM, column_num, (LPARAM)&hi);
	return hi.cxy;
}

HEADER_CC::set_column(int column_num, char* str, int column_width){
	HDITEM hi;
	memset(&hi, 0, sizeof(HDITEM));
	hi.mask = HDI_TEXT | HDI_WIDTH  | HDI_ORDER;
	hi.pszText = str;
	hi.cchTextMax = strlen(str);
	hi.cxy = column_width;
	hi.lParam = strlen(str);
	hi.iOrder = column_num;
	return SendMessage(m_hwnd, HDM_SETITEM, column_num, (LPARAM)&hi);
}
HEADER_CC::set_column_width(int column_num, int column_width){
	HDITEM hi;
	memset(&hi, 0, sizeof(HDITEM));
	hi.mask = HDI_WIDTH;
	hi.pszText = NULL;
	hi.cchTextMax = 0;
	hi.cxy = column_width;
	hi.lParam = NULL;
	hi.iOrder = column_num;
	return SendMessage(m_hwnd, HDM_SETITEM, column_num, (LPARAM)&hi);
}
#endif	//_GOBJ_H_
