
// `Rs[

#include <stdio.h>
#include <windows.h>
#include "gt_img_parts.h"

// ======== GT_IMG ==================================
class GT_IMG {
	public :
	GT_COL_TABLE m_col_table;
	unsigned long *m_col_mask;
	char *m_alpha;

	int m_width, m_height, m_byte_width, m_bit_count;
	BYTE *m_pbits;

	GT_IMG();
	virtual ~GT_IMG();

	// 쐬Ɣj
	virtual destroy();
	virtual create(int cx, int cy, int a_bit_count, int a_color_size=0);

	// sNZ`
	set_pixel(int x, int y, DWORD col);
	DWORD get_pixel(int x, int y);

	// At@l
	is_alpha(){ return (m_alpha!=NULL); }

	// ptO萔
	enum { ID_BLEND=0, ID_NOBLEND=1 };

	// `hԂ
	fill(int x, int y, int cx, int cy, BYTE r, BYTE g, BYTE b, int rate=255, int flag=ID_BLEND);
	template <int d_bit> void fill_pixput(int x, int y, int cx, int cy, BYTE r, BYTE g, BYTE b, int rate, int flag);

	// `Rs[
	from_draw(int x, int y, int cx, int cy, GT_IMG *p_img, int src_x, int src_y, int rate=255, int flag=ID_BLEND);
	template <int dst_bit, int src_bit> void 
	from_draw_set_alpha(int dst_x, int dst_y, int cx, int cy, GT_IMG *p_img, int src_x, int src_y, int rate, int flag);
	template <int dst_bit, int dst_alpha, int src_bit, int src_alpha> void 
	from_draw_pixput(int dst_x, int dst_y, int cx, int cy, GT_IMG *p_img, int src_x, int src_y, int rate, int flag);

	to_draw(int x, int y, int cx, int cy, GT_IMG *p_img, int src_x, int src_y, int rate=255, int flag=ID_BLEND);

	// J[
	set_col_mask(UINT r, UINT g, UINT b);
	set_pal_col(BYTE index, BYTE r, BYTE g, BYTE b);

	// Ǎ
	load_dib(char *filename);
	load_dib_rle4(HANDLE hfile);	// 4bit OXk
	load_dib_rle8(HANDLE hfile);	// 8bit OXk

	// 
	save_dib(char *filename, int rle_compress_flag=0);
	save_dib_rle4(HANDLE hfile);	// 4bit OXk
	save_dib_rle8(HANDLE hfile);	// 8bit OXk

};

//==========`Rs[==========
// `Rs[(to)
GT_IMG::to_draw(int dst_x, int dst_y, int cx, int cy, GT_IMG *p_img, int src_x, int src_y, int rate, int flag){
	return from_draw(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag);
}

// `Rs[(from)
GT_IMG::from_draw(int dst_x, int dst_y, int cx, int cy, GT_IMG *p_img, int src_x, int src_y, int rate, int flag){
	if (!p_img) return -1;
	if (!p_img->m_pbits || !m_pbits) return -1;

	// }CiXW̕␳
	if (dst_x<0){ cx+= dst_x; src_x-=dst_x; dst_x=0; };
	if (dst_y<0){ cy+= dst_y; src_y-=dst_y; dst_y=0; };
	if (src_x<0){ cx+= src_x; dst_x-=src_x; src_x=0; };
	if (src_y<0){ cy+= src_y; dst_y-=src_y; src_y=0; };
	// ERs[̕␳
	if ((dst_x+cx)>m_width)			{ cx=		m_width -dst_x;};
	if ((dst_y+cy)>m_height)		{ cy=		m_height-dst_y;};
	if ((src_x+cx)>p_img->m_width) 	{ cx=p_img->m_width -src_x;};
	if ((src_y+cy)>p_img->m_height)	{ cy=p_img->m_height-src_y;};

	switch(m_bit_count){
	case 1:
		switch(p_img->m_bit_count){
		case 1:  from_draw_set_alpha<1 , 1 >(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		case 4:  from_draw_set_alpha<1 , 4 >(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		case 8:  from_draw_set_alpha<1 , 8 >(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		case 16: from_draw_set_alpha<1 , 16>(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		case 24: from_draw_set_alpha<1 , 24>(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		case 32: from_draw_set_alpha<1 , 32>(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		}
		break;
	case 4:
		switch(p_img->m_bit_count){
		case 1:  from_draw_set_alpha<4 , 1 >(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		case 4:  from_draw_set_alpha<4 , 4 >(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		case 8:  from_draw_set_alpha<4 , 8 >(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		case 16: from_draw_set_alpha<4 , 16>(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		case 24: from_draw_set_alpha<4 , 24>(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		case 32: from_draw_set_alpha<4 , 32>(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		}
		break;
	case 8:
		switch(p_img->m_bit_count){
		case 1:  from_draw_set_alpha<8 , 1 >(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		case 4:  from_draw_set_alpha<8 , 4 >(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		case 8:  from_draw_set_alpha<8 , 8 >(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		case 16: from_draw_set_alpha<8 , 16>(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		case 24: from_draw_set_alpha<8 , 24>(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		case 32: from_draw_set_alpha<8 , 32>(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		}
		break;
	case 16:
		switch(p_img->m_bit_count){
		case 1:  from_draw_set_alpha<16, 1 >(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		case 4:  from_draw_set_alpha<16, 4 >(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		case 8:  from_draw_set_alpha<16, 8 >(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		case 16: from_draw_set_alpha<16, 16>(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		case 24: from_draw_set_alpha<16, 24>(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		case 32: from_draw_set_alpha<16, 32>(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		}
		break;
	case 24:
		switch(p_img->m_bit_count){
		case 1:  from_draw_set_alpha<24, 1 >(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		case 4:  from_draw_set_alpha<24, 4 >(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		case 8:  from_draw_set_alpha<24, 8 >(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		case 16: from_draw_set_alpha<24, 16>(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		case 24: from_draw_set_alpha<24, 24>(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		case 32: from_draw_set_alpha<24, 32>(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		}
		break;
	case 32:
		switch(p_img->m_bit_count){
		case 1:  from_draw_set_alpha<32, 1 >(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		case 4:  from_draw_set_alpha<32, 4 >(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		case 8:  from_draw_set_alpha<32, 8 >(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		case 16: from_draw_set_alpha<32, 16>(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		case 24: from_draw_set_alpha<32, 24>(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		case 32: from_draw_set_alpha<32, 32>(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag); break;
		}
		break;
	}
	return 0;
}
// `Rs[̃CCEev[g
template <int dst_bit, int src_bit> void 
GT_IMG::from_draw_set_alpha(int dst_x, int dst_y, int cx, int cy, GT_IMG *p_img, int src_x, int src_y, int rate, int flag){
	if (is_alpha()){
		if (p_img->is_alpha())
			from_draw_pixput<dst_bit, 1, src_bit, 1>(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag);
		else
			from_draw_pixput<dst_bit, 1, src_bit, 0>(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag);
	}
	else {
		if (p_img->is_alpha())
			from_draw_pixput<dst_bit, 0, src_bit, 1>(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag);
		else
			from_draw_pixput<dst_bit, 0, src_bit, 0>(dst_x, dst_y, cx, cy, p_img, src_x, src_y, rate, flag);
	}
}

// `Rs[̃CCEev[g
template <int dst_bit, int dst_alpha, int src_bit, int src_alpha> void 
GT_IMG::from_draw_pixput(int dst_x, int dst_y, int cx, int cy, GT_IMG *p_img, int src_x, int src_y, int rate, int flag){

	PIXEL_ITR<dst_bit, dst_alpha> d_pix;
	PIXEL_ITR<src_bit, src_alpha> s_pix;
	BYTE *p_alpha;
	if (rate<0) return ; else if (rate>=255) rate=255;
	d_pix.init(m_pbits, m_alpha, m_byte_width, m_width, m_height, &m_col_table);
	s_pix.init(p_img->m_pbits, p_img->m_alpha, p_img->m_byte_width, p_img->m_width, p_img->m_height, &p_img->m_col_table);
	int ix, iy;
	if (rate>=255){
		// sRs[
		for(iy=0;iy<cy;iy++){
			s_pix.set_pos(src_x, src_y+iy);
			d_pix.set_pos(dst_x, dst_y+iy);
			for(ix=0;ix<cx;ix++){ s_pix.to_draw(d_pix); d_pix++;s_pix++; }
		}
	}
	// Rs[
	else if (flag & ID_NOBLEND) {
		// Rs[(uh)
		for(iy=0;iy<cy;iy++){
			s_pix.set_pos(src_x, src_y+iy);
			d_pix.set_pos(dst_x, dst_y+iy);
			for(ix=0;ix<cx;ix++){ s_pix.to_no_blend_draw(d_pix, rate); d_pix++;s_pix++; }
		}
	}
	else {
		// Rs[(uhL)
		for(iy=0;iy<cy;iy++){
			s_pix.set_pos(src_x, src_y+iy);
			d_pix.set_pos(dst_x, dst_y+iy);
			for(ix=0;ix<cx;ix++){ s_pix.to_blend_draw(d_pix, rate); d_pix++;s_pix++; }
		}
	}
};
//==========``==========
// `hԂ̃CCEev[g
template <int d_bit> inline void 
GT_IMG::fill_pixput(int x, int y, int cx, int cy, BYTE r, BYTE g, BYTE b, int rate, int flag){
	PIXEL_ITR<d_bit,0> d_pix;
	d_pix.init(m_pbits, m_alpha, m_byte_width, m_width, m_height, &m_col_table);
	if (rate<0) rate=0;
	if (rate>=255) rate=255;
	int ix, iy;
	BYTE col_index;
	if (d_bit<=8 && rate>=255){	// (pbgŁEs) 
		col_index=m_col_table.get_col_index<d_bit>(r*rate/255, g*rate/255, b*rate/255);
		for(iy=0;iy<cy;iy++){
			d_pix.set_pos(x, y+iy);
			for(ix=0;ix<cx;ix++){ d_pix.set_col(col_index); d_pix++; }
		}
	}
	else if (flag & ID_NOBLEND) {
		// Fuh
		for(iy=0;iy<cy;iy++){
			d_pix.set_pos(x, y+iy);
			for(ix=0;ix<cx;ix++){ d_pix.set_col_no_blend(r, g, b, rate); d_pix++; }
		}
	}
	else {
		// FuhL
		for(iy=0;iy<cy;iy++){
			d_pix.set_pos(x, y+iy);
			for(ix=0;ix<cx;ix++){ d_pix.set_col(r, g, b, rate); d_pix++; }
		}
	}
};
// `hԂ
GT_IMG::fill(int x, int y, int cx, int cy, BYTE r, BYTE g, BYTE b, int rate, int flag){
	if (!m_pbits) return -1;

	if (cx<0) { x+=cx; cx=-cx; };
	if (cy<0) { y+=cy; cy=-cy; };

	// }CiXW̕␳
	if (x<0) { cx+=x; x=0; };
	if (y<0) { cy+=y; y=0; };
	// ERs[̕␳
	if ((x+cx)>=m_width) { cx=m_width -x;};
	if ((y+cy)>=m_height){ cy=m_height-y;};

	// Rs[
	switch(m_bit_count){
	case 1 : fill_pixput<1> (x, y, cx, cy, r, g, b, rate, flag);	 break;
	case 4 : fill_pixput<4> (x, y, cx, cy, r, g, b, rate, flag);	 break;
	case 8 : fill_pixput<8> (x, y, cx, cy, r, g, b, rate, flag);	 break;
	case 16: fill_pixput<16>(x, y, cx, cy, r, g, b, rate, flag);	 break;
	case 24: fill_pixput<24>(x, y, cx, cy, r, g, b, rate, flag);	 break;
	case 32: fill_pixput<32>(x, y, cx, cy, r, g, b, rate, flag);	 break;
	}
	return 0;
}

// RXgN^
GT_IMG::GT_IMG(){
	m_col_mask =NULL;
	m_alpha =NULL;
	m_width = m_height = m_byte_width = m_bit_count =0;
	m_pbits =NULL;
}
// fXgN^
GT_IMG::~GT_IMG(){
	destroy();
}
// GIMG j
GT_IMG::destroy(){
	m_width=0;
	m_height=0;
	m_byte_width=0;
	m_bit_count=0;
	if (m_pbits) delete[] m_pbits;
	m_pbits = NULL;
	if (m_col_mask) delete[] m_col_mask;
	m_col_mask = NULL;
	m_col_table.destroy();
	return 0;
};
// GIMG 쐬
GT_IMG::create(int cx, int cy, int a_bit_count, int a_color_size){
	int i, palette_len, info_size;
	destroy();	// t@CJf[^j

	if (cx<=0 || cy<=0) return -1;
	if (a_bit_count!=1 && a_bit_count!=4 && a_bit_count!=8
		&& a_bit_count!=16 && a_bit_count!=24 && a_bit_count!=32) return -1;

	if (a_bit_count<=8 && a_color_size==0)  palette_len=1<<a_bit_count;	// 8bitȉŃpbgFw薳Ȃ
	else palette_len=a_color_size;

	// pbgEm
	m_col_table.make(palette_len);

	/* obt@̂PC̒vZ */
	m_byte_width=4*((cx*a_bit_count+31)/32);
	m_pbits = new BYTE[m_byte_width*cy];
	ZeroMemory(m_pbits, m_byte_width*cy);

	if (!m_pbits) return -1;
	m_width= cx;
	m_height=cy;
	m_bit_count=a_bit_count;

	// pbgzF
	// KȊ{F
	RGBTRIPLE rgb[8]={
		{0,0,0},{255, 255, 255}, {0,0,255}, {255,0,0}, {0,255,0}, {255, 255,0}, {255,0,255},{0,255,255}
	};

	for(i=0;i<min(palette_len, 8);i++){
		m_col_table.add_col(rgb[i].rgbtRed, rgb[i].rgbtGreen, rgb[i].rgbtBlue);
	}

	return 0;
}
// pbgɐFݒ
inline GT_IMG::set_pal_col(BYTE index, BYTE r, BYTE g, BYTE b){
	if (m_col_table.m_cols_len<=index) return -1;
	m_col_table.set_col(index, r, g, b);
	return 0;
}
// J[}XNݒ
GT_IMG::set_col_mask(UINT r, UINT g, UINT b){
	if (!m_col_mask) m_col_mask = new unsigned long[3];
	m_col_mask[0] = r;
	m_col_mask[1] = g;
	m_col_mask[2] = b;
}
// P_sNZ擾
DWORD GT_IMG::get_pixel(int x, int y){
	if (!m_pbits) return 0;
	if (x<0 || x>=m_width || y<0 || y>=m_height) return 0;
	BYTE *ppix;
	ppix=m_pbits+(m_height-y-1)*m_byte_width + (x*m_bit_count>>3);

	switch(m_bit_count){
	case 1: return 0x01 & (*ppix >> (7-(x&7)));
	case 4: return 0x0f & (*ppix >> ((x&1)?0:4));
	case 8: return *ppix ;
	case 16: return *(WORD*)ppix;
	case 24: return 0x00FFffFF & *(DWORD*)ppix;
	case 32: return *(DWORD*)ppix ;
	}
	return 0;
}
// P_sNZ
GT_IMG::set_pixel(int x, int y, DWORD col){
	if (!m_pbits) return 0;
	if (x<0 || x>=m_width || y<0 || y>=m_height) return 0;
	BYTE *ppix;
	ppix=m_pbits+(m_height-y-1)*m_byte_width + (x*m_bit_count>>3);

	switch(m_bit_count){
	case 1: *ppix &= ~(1		 <<(7-(x&7)));
			*ppix |= ((bool)col) <<(7-(x&7));
			break;
	case 4: *ppix &= 0x0f << ((x&1)?4:0);
			*ppix |= (0x0f & col)  << ((x&1)?0:4);
			break;
	case 8: *ppix = (BYTE)col;							break;
	case 16: *(WORD*)ppix = (WORD)col;					break;
	case 24: *(RGBTRIPLE*)ppix = *(RGBTRIPLE*)&col;		break;
	case 32: *(DWORD*)ppix = *(DWORD*)&col;				break;
	}
	return 0;
}

// ======== GT_DIB ==================================
class GT_DIB : public GT_IMG{
	public :
	HDC m_hdc;
	HBITMAP m_hbmp;

	GT_DIB();
	~GT_DIB();

	// DC Kp
	apply_dc(HDC hdc=NULL);
	apply_dc(HWND hwnd);

	// 쐬Ɣj
	create(int cx, int cy, int a_bit_count, int a_color_size=0);
	virtual destroy();

	// J[
	apply_palette_all();
	set_pal_col(BYTE index, BYTE r, BYTE g, BYTE b);

};
// RXgN^
GT_DIB::GT_DIB(){
	m_hdc = NULL;
	m_hbmp = NULL;
}
// fXgN^
GT_DIB::~GT_DIB(){
	destroy();
}
// HDCpbgݒ(Sāj
GT_DIB::apply_palette_all(){
	return m_col_table.apply_palette_all(m_hdc);
}
// pbgɐFݒ
inline GT_DIB::set_pal_col(BYTE index, BYTE r, BYTE g, BYTE b){
	return m_col_table.set_pal_col(m_hdc, index, r, g, b);
}

// cbL
GT_DIB::apply_dc(HDC hdc){
	if (m_hdc) { DeleteDC(m_hdc);	m_hdc=NULL; }
	m_hdc = CreateCompatibleDC(hdc);
	SelectObject(m_hdc, m_hbmp);
	return 0;
}
// cbL(HWND hwnd) 
GT_DIB::apply_dc(HWND hwnd){
	if (m_hdc) { DeleteDC(m_hdc);	m_hdc=NULL; }
	HDC hwnd_hdc = GetDC(hwnd);
	m_hdc = CreateCompatibleDC(hwnd_hdc);
	SelectObject(m_hdc, m_hbmp);
	ReleaseDC(hwnd, hwnd_hdc);
	return 0;
}

// j
GT_DIB::destroy(){
	if (m_hdc)		{ DeleteDC(m_hdc);	m_hdc=NULL; }
	if (m_hbmp)		{ DeleteObject(m_hbmp); m_hbmp=NULL; }
//	if (m_pbits) delete[] m_pbits;
	m_pbits = NULL;
	m_width=0;
	m_height=0;
	m_byte_width=0;
	m_bit_count=0;
	if (m_col_mask) delete[] m_col_mask;
	m_col_mask = NULL;
	m_col_table.destroy();
	return 0;
}
// 쐬
GT_DIB::create(int cx, int cy, int a_bit_count, int a_color_size){
	BITMAPINFO *bmp_info;
	int i, palette_entry, info_size;
	destroy();	// 쐬ς݃j

	if (cx<=0 || cy<=0) return -1;
	if (a_bit_count!=1 && a_bit_count!=4 && a_bit_count!=8
		&& a_bit_count!=16 && a_bit_count!=24 && a_bit_count!=32) return -1;

	palette_entry=1;
	if		(a_color_size!=0) palette_entry=a_color_size;
	else if (a_bit_count<=8)  palette_entry=1<<a_bit_count;	// 8bitȉŃpbgFw薳Ȃ

	info_size=sizeof(BITMAPINFOHEADER) + (palette_entry-1)*sizeof(RGBQUAD)+1;
	bmp_info = (BITMAPINFO*)malloc(info_size);
	if (!bmp_info) return -1;
	ZeroMemory(bmp_info, info_size);

	// KȊ{F
	RGBTRIPLE rgb[8]={
		{0,0,0},{255, 255, 255}, {0,0,255}, {255,0,0}, {0,255,0}, {255, 255,0}, {255,0,255},{0,255,255}
	};

	m_col_table.make(palette_entry);
	for(i=0;i<min(palette_entry, 8);i++){
		bmp_info->bmiColors[i].rgbBlue	= rgb[i].rgbtBlue;
		bmp_info->bmiColors[i].rgbGreen	= rgb[i].rgbtGreen;
		bmp_info->bmiColors[i].rgbRed	= rgb[i].rgbtRed;
		bmp_info->bmiColors[i].rgbReserved = 0;
		m_col_table.add_col(rgb[i].rgbtRed, rgb[i].rgbtGreen, rgb[i].rgbtBlue);
	}

	/* BITMAPINFO\̐ݒ */
	bmp_info->bmiHeader.biSize=sizeof(BITMAPINFOHEADER);
	bmp_info->bmiHeader.biWidth=cx;
	bmp_info->bmiHeader.biHeight=cy;
	bmp_info->bmiHeader.biPlanes=1;
	bmp_info->bmiHeader.biBitCount=a_bit_count;
	bmp_info->bmiHeader.biCompression=BI_RGB;
	bmp_info->bmiHeader.biSizeImage=0;
	bmp_info->bmiHeader.biXPelsPerMeter=0;
	bmp_info->bmiHeader.biYPelsPerMeter=0;
	bmp_info->bmiHeader.biClrUsed=palette_entry;
	bmp_info->bmiHeader.biClrImportant=0;

	m_hbmp = CreateDIBSection(NULL, bmp_info, DIB_RGB_COLORS, (VOID**)&m_pbits, NULL, 0);
	if (!m_hbmp) {
		free(bmp_info);
		return -1;
	}
	m_width= cx;
	m_height=cy;
	m_bit_count=a_bit_count;

	/* obt@̂PC̒vZ */
	m_byte_width=4*((m_width*m_bit_count+31)/32);
	ZeroMemory(m_pbits, m_byte_width*m_height);

	free(bmp_info);
	return 0;
}

