
#ifndef _GT_IMG_PARTS_H_
#define _GT_IMG_PARTS_H_

// ====== GT_COL ==========================
class GT_COL {
	public :
	BYTE m_r, m_g, m_b;
	GT_COL(){ m_r=m_g=m_b=0; }
};
// ====== GT_COL_TABLE ==========================
class GT_COL_TABLE {
	public :
	GT_COL *m_cols;
	int m_cols_len;
	int m_using_cols_len;
	GT_COL_TABLE(){
		m_cols=NULL;
		m_cols_len=0;
		m_using_cols_len=0;
	}
	~GT_COL_TABLE(){ destroy(); }
	make(int col_size){
		destroy();
		if (!col_size) return -1;
		m_cols = new GT_COL[col_size];
		m_cols_len = col_size;
		m_using_cols_len=0;
	}
	destroy(){
		if (m_cols) delete[] m_cols;
		m_cols = NULL;
		m_using_cols_len=0;
		m_cols_len = 0;
	};
	template <int bit> BYTE get_col_index(BYTE r, BYTE g, BYTE b);
	add_col(BYTE r, BYTE g, BYTE b);
	void set_col(BYTE index, BYTE r, BYTE g, BYTE b);


	apply_palette_all(HDC hdc);	// HDCpbgݒ(Sāj
	set_pal_col(HDC hdc, BYTE index, BYTE r, BYTE g, BYTE b);// pbgɐFݒ
};
// ߎFpbg擾
template <int bit>
BYTE GT_COL_TABLE::get_col_index(BYTE r, BYTE g, BYTE b){
	GT_COL *pcol;
	if (!m_cols) return -1;
	int i, min_apx=255*255*3+1, apx, min_apx_index;
	min_apx_index=0;
	for(i=0;i<m_using_cols_len;i++){
		pcol=&m_cols[i];
		apx=(r-pcol->m_r)*(r-pcol->m_r)+(g-pcol->m_g)*(g-pcol->m_g)+(b-pcol->m_b)*(b-pcol->m_b);
		if (apx<min_apx){
			min_apx_index=i;
			min_apx=apx;
		}
	}
	i=1<<bit;
	if (bit && min_apx>(255*255*3/(i*i)) && m_using_cols_len<m_cols_len){
		min_apx_index = add_col(r, g, b);
	}
	return min_apx_index;
}
// pbgɒǉ
GT_COL_TABLE::add_col(BYTE r, BYTE g, BYTE b){
	GT_COL *pcol;
	int res_index;
	if (m_using_cols_len>=m_cols_len) return -1;
	pcol=&m_cols[m_using_cols_len];
	pcol->m_r=r;
	pcol->m_g=g;
	pcol->m_b=b;
	res_index=m_using_cols_len;
	m_using_cols_len++;
	return res_index;
}
// pbgɐFݒ
inline void GT_COL_TABLE::set_col(BYTE index, BYTE r, BYTE g, BYTE b){
	if (m_cols_len<=index) return ;
	GT_COL *pcol;
	pcol=&(m_cols[index]);
	pcol->m_r = r;
	pcol->m_g = g;
	pcol->m_b = b;
}

// pbgɐFݒ
GT_COL_TABLE::set_pal_col(HDC hdc, BYTE index, BYTE r, BYTE g, BYTE b){
	if (m_cols_len<=index) return -1;
	set_col(index, r, g, b);
	if (!hdc) return -1;

	RGBQUAD rgb;
	rgb.rgbRed		=r;
	rgb.rgbGreen	=g;
	rgb.rgbBlue		=b;
	rgb.rgbReserved	=0;
	if (hdc) SetDIBColorTable(hdc, index, 1, &rgb);
	return 0;
}

// HDCpbgݒ(Sāj
GT_COL_TABLE::apply_palette_all(HDC hdc){
	if (!m_cols_len || !hdc) return -1;
	RGBQUAD *p_rgb, *rgb_table;
	rgb_table=new RGBQUAD[m_cols_len];
	for (int i=0;i<m_cols_len;i++){
		p_rgb=&(rgb_table[i]);
		p_rgb->rgbRed	=m_cols[i].m_r;
		p_rgb->rgbGreen	=m_cols[i].m_g;
		p_rgb->rgbBlue	=m_cols[i].m_b;
		p_rgb->rgbReserved=0;
	}
	if (hdc) SetDIBColorTable(hdc, 0, m_cols_len, rgb_table);
	delete[] rgb_table;
	return 0;
}

// ====== sNZECe[^ ========================
template <int bit> class PIXEL_ITR_BASE {
	public :
	GT_COL_TABLE *m_p_col_table;
	int m_byte_width, m_height;
	BYTE *m_start_pbits;
	BYTE *m_pbits;
	BYTE m_bit_pos;

	init(char *start_pbits, int img_byte_width, int img_height, GT_COL_TABLE *p_col_table){
		m_start_pbits = start_pbits;
		m_byte_width  = img_byte_width;
		m_height = img_height;
		m_p_col_table = p_col_table;
		set_pos(0,0);
	};
	BYTE *get_pos_p(int ix, int iy){ return m_start_pbits+(m_height-iy-1)*m_byte_width + (ix*bit>>3); }
	set_pos(int x, int y){
		m_pbits = get_pos_p(x, y);
		set_bit_pos(x);
	}

	void set_bit_pos(int n){ set_bit_pos_static(*this, n); };
	static void set_bit_pos_static(PIXEL_ITR_BASE<1 > &pix, int n){ pix.m_bit_pos=n&7; };
	static void set_bit_pos_static(PIXEL_ITR_BASE<4 > &pix, int n){ pix.m_bit_pos=(n&1)*4; };
	static void set_bit_pos_static(PIXEL_ITR_BASE<8 > &pix, int n){};
	static void set_bit_pos_static(PIXEL_ITR_BASE<16> &pix, int n){};
	static void set_bit_pos_static(PIXEL_ITR_BASE<24> &pix, int n){};
	static void set_bit_pos_static(PIXEL_ITR_BASE<32> &pix, int n){};

	// J[Zbg
	static void set_col_by_index(PIXEL_ITR_BASE<1>  &d_pix, BYTE col_index);
	static void set_col_by_index(PIXEL_ITR_BASE<4>  &d_pix, BYTE col_index);
	static void set_col_by_index(PIXEL_ITR_BASE<8>  &d_pix, BYTE col_index);
	static void set_col_by_index(PIXEL_ITR_BASE<16>  &d_pix, BYTE col_index);
	static void set_col_by_index(PIXEL_ITR_BASE<24>  &d_pix, BYTE col_index);
	static void set_col_by_index(PIXEL_ITR_BASE<32>  &d_pix, BYTE col_index);

	static void set_col_no_blend(PIXEL_ITR_BASE<1>  &d_pix, BYTE r, BYTE g, BYTE b, int rate);
	static void set_col_no_blend(PIXEL_ITR_BASE<4>  &d_pix, BYTE r, BYTE g, BYTE b, int rate);
	static void set_col_no_blend(PIXEL_ITR_BASE<8>  &d_pix, BYTE r, BYTE g, BYTE b, int rate);
	static void set_col_no_blend(PIXEL_ITR_BASE<16> &d_pix, BYTE r, BYTE g, BYTE b, int rate);
	static void set_col_no_blend(PIXEL_ITR_BASE<24> &d_pix, BYTE r, BYTE g, BYTE b, int rate);
	static void set_col_no_blend(PIXEL_ITR_BASE<32> &d_pix, BYTE r, BYTE g, BYTE b, int rate);

	static void set_col(PIXEL_ITR_BASE<1>  &d_pix, BYTE r, BYTE g, BYTE b, int rate);
	static void set_col(PIXEL_ITR_BASE<4>  &d_pix, BYTE r, BYTE g, BYTE b, int rate);
	static void set_col(PIXEL_ITR_BASE<8>  &d_pix, BYTE r, BYTE g, BYTE b, int rate);
	static void set_col(PIXEL_ITR_BASE<16> &d_pix, BYTE r, BYTE g, BYTE b, int rate);
	static void set_col(PIXEL_ITR_BASE<24> &d_pix, BYTE r, BYTE g, BYTE b, int rate);
	static void set_col(PIXEL_ITR_BASE<32> &d_pix, BYTE r, BYTE g, BYTE b, int rate);

	void to_draw(PIXEL_ITR_BASE<1> &d_pix);
	void to_draw(PIXEL_ITR_BASE<4> &d_pix);
	void to_draw(PIXEL_ITR_BASE<8> &d_pix);
	void to_draw(PIXEL_ITR_BASE<16> &d_pix);
	void to_draw(PIXEL_ITR_BASE<24> &d_pix);
	void to_draw(PIXEL_ITR_BASE<32> &d_pix);

	void virtual to_no_blend_draw(PIXEL_ITR_BASE<1> &d_pix, int rate);
	void virtual to_no_blend_draw(PIXEL_ITR_BASE<4> &d_pix, int rate);
	void virtual to_no_blend_draw(PIXEL_ITR_BASE<8> &d_pix, int rate);
	void virtual to_no_blend_draw(PIXEL_ITR_BASE<16> &d_pix, int rate);
	void virtual to_no_blend_draw(PIXEL_ITR_BASE<24> &d_pix, int rate);
	void virtual to_no_blend_draw(PIXEL_ITR_BASE<32> &d_pix, int rate);

	void virtual to_blend_draw(PIXEL_ITR_BASE<1> &d_pix, int rate);
	void virtual to_blend_draw(PIXEL_ITR_BASE<4> &d_pix, int rate);
	void virtual to_blend_draw(PIXEL_ITR_BASE<8> &d_pix, int rate);
	void virtual to_blend_draw(PIXEL_ITR_BASE<16> &d_pix, int rate);
	void virtual to_blend_draw(PIXEL_ITR_BASE<24> &d_pix, int rate);
	void virtual to_blend_draw(PIXEL_ITR_BASE<32> &d_pix, int rate);


	// Z
	void virtual operator +=(int dx){ add(*this, dx); };
	static void add(PIXEL_ITR_BASE<1>  &pix, int dx){
		pix.m_pbits+=dx/8; pix.m_bit_pos+=dx%8; if (pix.m_bit_pos>=8) { pix.m_pbits++; pix.m_bit_pos=pix.m_bit_pos%8; } };
	static void add(PIXEL_ITR_BASE<4>  &pix, int dx){ pix.m_pbits+=dx/2; if (dx&1) increment(pix); };
	static void add(PIXEL_ITR_BASE<8>  &pix, int dx){ pix.m_pbits+=dx;  };
	static void add(PIXEL_ITR_BASE<16> &pix, int dx){ pix.m_pbits+=2*dx; };
	static void add(PIXEL_ITR_BASE<24> &pix, int dx){ pix.m_pbits+=3*dx; };
	static void add(PIXEL_ITR_BASE<32> &pix, int dx){ pix.m_pbits+=4*dx; };

	// CNg
	void virtual operator ++(){ increment(*this); };
	static void increment(PIXEL_ITR_BASE<1>  &pix){ if (pix.m_bit_pos<7) pix.m_bit_pos++; else { pix.m_pbits++; pix.m_bit_pos=0; } };
	static void increment(PIXEL_ITR_BASE<4>  &pix){ if (!pix.m_bit_pos)  pix.m_bit_pos=4; else { pix.m_pbits++; pix.m_bit_pos=0; } };
	static void increment(PIXEL_ITR_BASE<8>  &pix){ pix.m_pbits++;  };
	static void increment(PIXEL_ITR_BASE<16> &pix){ pix.m_pbits+=2; };
	static void increment(PIXEL_ITR_BASE<24> &pix){ pix.m_pbits+=3; };
	static void increment(PIXEL_ITR_BASE<32> &pix){ pix.m_pbits+=4; };

	// fNg
	void virtual operator --(){ decrement(*this); };
	static void decrement(PIXEL_ITR_BASE<1>  &pix){ if (pix.m_bit_pos>0) pix.m_bit_pos--; else { pix.m_pbits--; pix.m_bit_pos=7; } };
	static void decrement(PIXEL_ITR_BASE<4>  &pix){ if (pix.m_bit_pos)   pix.m_bit_pos=0; else { pix.m_pbits--; pix.m_bit_pos=4; } };
	static void decrement(PIXEL_ITR_BASE<8>  &pix){ pix.m_pbits--;  };
	static void decrement(PIXEL_ITR_BASE<16> &pix){ pix.m_pbits-=2; };
	static void decrement(PIXEL_ITR_BASE<24> &pix){ pix.m_pbits-=3; };
	static void decrement(PIXEL_ITR_BASE<32> &pix){ pix.m_pbits-=4; };

	// F擾ipbglj
	static get_index(PIXEL_ITR_BASE<1> &pix){ return (0x01 & ((*pix.m_pbits)>>(7-pix.m_bit_pos))); }
	static get_index(PIXEL_ITR_BASE<4> &pix){ return (0x0f & ((*pix.m_pbits)>>(4-pix.m_bit_pos))); }
	static get_index(PIXEL_ITR_BASE<8> &pix){ return *pix.m_pbits; }
	static get_index(PIXEL_ITR_BASE<16> &pix){ return 0; }
	static get_index(PIXEL_ITR_BASE<24> &pix){ return 0; }
	static get_index(PIXEL_ITR_BASE<32> &pix){ return 0; }

	// F擾
	static get_red	(PIXEL_ITR_BASE<1> &pix){ return pix.m_p_col_table->m_cols[0x01 & ((*pix.m_pbits)>>(7-pix.m_bit_pos))].m_r; };
	static get_green(PIXEL_ITR_BASE<1> &pix){ return pix.m_p_col_table->m_cols[0x01 & ((*pix.m_pbits)>>(7-pix.m_bit_pos))].m_g; };
	static get_blue	(PIXEL_ITR_BASE<1> &pix){ return pix.m_p_col_table->m_cols[0x01 & ((*pix.m_pbits)>>(7-pix.m_bit_pos))].m_b; };

	static get_red	(PIXEL_ITR_BASE<4> &pix){ return pix.m_p_col_table->m_cols[0x0f & ((*pix.m_pbits)>>(4-pix.m_bit_pos))].m_r; };
	static get_green(PIXEL_ITR_BASE<4> &pix){ return pix.m_p_col_table->m_cols[0x0f & ((*pix.m_pbits)>>(4-pix.m_bit_pos))].m_g; };
	static get_blue	(PIXEL_ITR_BASE<4> &pix){ return pix.m_p_col_table->m_cols[0x0f & ((*pix.m_pbits)>>(4-pix.m_bit_pos))].m_b; };

	static get_red	(PIXEL_ITR_BASE<8> &pix){ return pix.m_p_col_table->m_cols[*pix.m_pbits].m_r; };
	static get_green(PIXEL_ITR_BASE<8> &pix){ return pix.m_p_col_table->m_cols[*pix.m_pbits].m_g; };
	static get_blue	(PIXEL_ITR_BASE<8> &pix){ return pix.m_p_col_table->m_cols[*pix.m_pbits].m_b; };

	static get_red	(PIXEL_ITR_BASE<16> &pix){ return (((*(WORD*)pix.m_pbits) & 0x7c00)>>10)<<3; };
	static get_green(PIXEL_ITR_BASE<16> &pix){ return (((*(WORD*)pix.m_pbits) & 0x03e0)>>5) <<3; };
	static get_blue	(PIXEL_ITR_BASE<16> &pix){ return  ((*(WORD*)pix.m_pbits) & 0x001f)     <<3; };

	static get_red	(PIXEL_ITR_BASE<24> &pix){ return pix.m_pbits[2]; };
	static get_green(PIXEL_ITR_BASE<24> &pix){ return pix.m_pbits[1]; };
	static get_blue	(PIXEL_ITR_BASE<24> &pix){ return pix.m_pbits[0]; };

	static get_red	(PIXEL_ITR_BASE<32> &pix){ return pix.m_pbits[2]; };
	static get_green(PIXEL_ITR_BASE<32> &pix){ return pix.m_pbits[1]; };
	static get_blue	(PIXEL_ITR_BASE<32> &pix){ return pix.m_pbits[0]; };

};
//==========PIXEL_ITR_BASE FZbgipbgj========================================
template <int bit> inline void PIXEL_ITR_BASE<bit>::set_col_by_index(PIXEL_ITR_BASE<1> &d_pix, BYTE col_index){
	*d_pix.m_pbits = ((1 & col_index) << (7-d_pix.m_bit_pos))
					| (*d_pix.m_pbits & ~(BYTE)(1 << (7-d_pix.m_bit_pos))) ;
}
template <int bit> inline void PIXEL_ITR_BASE<bit>::set_col_by_index(PIXEL_ITR_BASE<4> &d_pix, BYTE col_index){
	*d_pix.m_pbits = (col_index << (4-d_pix.m_bit_pos)) | (*d_pix.m_pbits & (0x0f << d_pix.m_bit_pos));
}
template <int bit> inline void PIXEL_ITR_BASE<bit>::set_col_by_index(PIXEL_ITR_BASE<8> &d_pix, BYTE col_index){
	*d_pix.m_pbits = col_index;
}
template <int bit> inline void PIXEL_ITR_BASE<bit>::set_col_by_index(PIXEL_ITR_BASE<16> &d_pix, BYTE col_index){
	GT_COL col;
	if (d_pix.m_p_col_table && d_pix.m_p_col_table->m_cols_len>col_index){
		col = d_pix.m_p_col_table->m_cols[col_index];
		set_col(d_pix, col.m_r, col.m_g, col.m_b, 255);
	}
}
template <int bit> inline void PIXEL_ITR_BASE<bit>::set_col_by_index(PIXEL_ITR_BASE<24> &d_pix, BYTE col_index){
	GT_COL col;
	if (d_pix.m_p_col_table && d_pix.m_p_col_table->m_cols_len>col_index){
		col = d_pix.m_p_col_table->m_cols[col_index];
		set_col(d_pix, col.m_r, col.m_g, col.m_b, 255);
	}
}
template <int bit> inline void PIXEL_ITR_BASE<bit>::set_col_by_index(PIXEL_ITR_BASE<32> &d_pix, BYTE col_index){
	GT_COL col;
	if (d_pix.m_p_col_table && d_pix.m_p_col_table->m_cols_len>col_index){
		col = d_pix.m_p_col_table->m_cols[col_index];
		set_col(d_pix, col.m_r, col.m_g, col.m_b, 255);
	}
}
//==========PIXEL_ITR_BASE FZbg(uh)============================================
template <int bit> inline void PIXEL_ITR_BASE<bit>::set_col(PIXEL_ITR_BASE<1> &d_pix, BYTE r, BYTE g, BYTE b, int rate){
	BYTE col_index = d_pix.m_p_col_table->get_col_index<1>(r, g, b);
	*d_pix.m_pbits = ((1 & col_index) << (7-d_pix.m_bit_pos))
					| (*d_pix.m_pbits & ~(BYTE)(1 << (7-d_pix.m_bit_pos))) ;
}
template <int bit> inline void PIXEL_ITR_BASE<bit>::set_col(PIXEL_ITR_BASE<4> &d_pix, BYTE r, BYTE g, BYTE b, int rate){
	r = (BYTE)((get_red  (d_pix) * (255-rate)/255)  + (r * rate/255));	// red
	g = (BYTE)((get_green(d_pix) * (255-rate)/255)  + (g * rate/255));	// green
	b = (BYTE)((get_blue (d_pix) * (255-rate)/255)  + (b * rate/255));	// blue

	BYTE col_index = d_pix.m_p_col_table->get_col_index<4>(r, g, b);
	*d_pix.m_pbits = (col_index << (4-d_pix.m_bit_pos)) | (*d_pix.m_pbits & (0x0f << d_pix.m_bit_pos));
}
template <int bit> inline void PIXEL_ITR_BASE<bit>::set_col(PIXEL_ITR_BASE<8> &d_pix, BYTE r, BYTE g, BYTE b, int rate){
	r = (BYTE)((get_red  (d_pix) * (255-rate)/255)  + (r * rate/255));	// red
	g = (BYTE)((get_green(d_pix) * (255-rate)/255)  + (g * rate/255));	// green
	b = (BYTE)((get_blue (d_pix) * (255-rate)/255)  + (b * rate/255));	// blue

	BYTE col_index = d_pix.m_p_col_table->get_col_index<8>(r, g, b);
	*d_pix.m_pbits = col_index;
}
template <int bit> inline void PIXEL_ITR_BASE<bit>::set_col(PIXEL_ITR_BASE<16> &d_pix, BYTE r, BYTE g, BYTE b, int rate){
	WORD *pw=(WORD*)d_pix.m_pbits;	// blue 8bit -> 5bit
	*pw=(WORD)(
			(((BYTE)(((get_red  (d_pix) * (255-rate)/255)  + (r* rate/255)))>>3)<<10)
		|	(((BYTE)(((get_green(d_pix) * (255-rate)/255)  + (g* rate/255)))>>3)<<5)
		|	( (BYTE)(((get_blue (d_pix) * (255-rate)/255)  + (b* rate/255)))>>3)
	);
}
template <int bit> inline void PIXEL_ITR_BASE<bit>::set_col(PIXEL_ITR_BASE<24> &d_pix, BYTE r, BYTE g, BYTE b, int rate){
		d_pix.m_pbits[2]=(BYTE)((get_red  (d_pix) * (255-rate)/255)  + (r * rate/255));	// red
		d_pix.m_pbits[1]=(BYTE)((get_green(d_pix) * (255-rate)/255)  + (g * rate/255));	// green
		d_pix.m_pbits[0]=(BYTE)((get_blue (d_pix) * (255-rate)/255)  + (b * rate/255));	// blue
}
template <int bit> inline void PIXEL_ITR_BASE<bit>::set_col(PIXEL_ITR_BASE<32> &d_pix, BYTE r, BYTE g, BYTE b, int rate){
		d_pix.m_pbits[2]=(BYTE)((get_red  (d_pix) * (255-rate)/255)  + (r * rate/255));	// red
		d_pix.m_pbits[1]=(BYTE)((get_green(d_pix) * (255-rate)/255)  + (g * rate/255));	// green
		d_pix.m_pbits[0]=(BYTE)((get_blue (d_pix) * (255-rate)/255)  + (b * rate/255));	// blue
}
//==========PIXEL_ITR_BASE FZbg(uh)============================================
template <int bit> inline void PIXEL_ITR_BASE<bit>::set_col_no_blend(PIXEL_ITR_BASE<1> &d_pix, BYTE r, BYTE g, BYTE b, int rate){
	BYTE col_index = d_pix.m_p_col_table->get_col_index<1>(r, g, b);
	*d_pix.m_pbits = ((1 & col_index) << (7-d_pix.m_bit_pos))
					| (*d_pix.m_pbits & ~(BYTE)(1 << (7-d_pix.m_bit_pos))) ;
}
template <int bit> inline void PIXEL_ITR_BASE<bit>::set_col_no_blend(PIXEL_ITR_BASE<4> &d_pix, BYTE r, BYTE g, BYTE b, int rate){
	r = (BYTE)(r * rate/255);	// red
	g = (BYTE)(g * rate/255);	// green
	b = (BYTE)(b * rate/255);	// blue

	BYTE col_index = d_pix.m_p_col_table->get_col_index<4>(r, g, b);
	*d_pix.m_pbits = (col_index << (4-d_pix.m_bit_pos)) | (*d_pix.m_pbits & (0x0f << d_pix.m_bit_pos));
}
template <int bit> inline void PIXEL_ITR_BASE<bit>::set_col_no_blend(PIXEL_ITR_BASE<8> &d_pix, BYTE r, BYTE g, BYTE b, int rate){
	r = (BYTE)(r * rate/255);	// red
	g = (BYTE)(g * rate/255);	// green
	b = (BYTE)(b * rate/255);	// blue

	*d_pix.m_pbits = d_pix.m_p_col_table->get_col_index<8>(r, g, b);
}
template <int bit> inline void PIXEL_ITR_BASE<bit>::set_col_no_blend(PIXEL_ITR_BASE<16> &d_pix, BYTE r, BYTE g, BYTE b, int rate){
	WORD *pw=(WORD*)d_pix.m_pbits;	// blue 8bit -> 5bit
	*pw=(WORD)(
			(((BYTE)(r* rate/255)>>3)<<10)
		|	(((BYTE)(g* rate/255)>>3)<<5)
		|	( (BYTE)(b* rate/255)>>3)
	);
}
template <int bit> inline void PIXEL_ITR_BASE<bit>::set_col_no_blend(PIXEL_ITR_BASE<24> &d_pix, BYTE r, BYTE g, BYTE b, int rate){
		d_pix.m_pbits[2]=(BYTE)(r * rate/255);	// red
		d_pix.m_pbits[1]=(BYTE)(g * rate/255);	// green
		d_pix.m_pbits[0]=(BYTE)(b * rate/255);	// blue
}
template <int bit> inline void PIXEL_ITR_BASE<bit>::set_col_no_blend(PIXEL_ITR_BASE<32> &d_pix, BYTE r, BYTE g, BYTE b, int rate){
		d_pix.m_pbits[2]=(BYTE)(r * rate/255);	// red
		d_pix.m_pbits[1]=(BYTE)(g * rate/255);	// green
		d_pix.m_pbits[0]=(BYTE)(b * rate/255);	// blue
}
//==========PIXEL_ITR_BASE `Rs[ijuhȂ=========================================
// 1 bit <- n bit ijuhȂ
template <int bit> inline void PIXEL_ITR_BASE<bit>::to_no_blend_draw(PIXEL_ITR_BASE<1> &d_pix, int rate){
	BYTE r, g, b;
	r = (BYTE)(get_red  (*this) * rate/255);	// red
	g = (BYTE)(get_green(*this) * rate/255);	// green
	b = (BYTE)(get_blue (*this) * rate/255);	// blue

	*d_pix.m_pbits = d_pix.m_p_col_table->get_col_index<1>(r, g, b);
}
// 4 bit <- n bit ijuhȂ
template <int bit> inline void PIXEL_ITR_BASE<bit>::to_no_blend_draw(PIXEL_ITR_BASE<4> &d_pix, int rate){
	BYTE r, g, b;
	r = (BYTE)(get_red  (*this) * rate/255);	// red
	g = (BYTE)(get_green(*this) * rate/255);	// green
	b = (BYTE)(get_blue (*this) * rate/255);	// blue

	*d_pix.m_pbits = d_pix.m_p_col_table->get_col_index<4>(r, g, b);
}
// 8 bit <- n bit ijuhȂ
template <int bit> inline void PIXEL_ITR_BASE<bit>::to_no_blend_draw(PIXEL_ITR_BASE<8> &d_pix, int rate){
	BYTE r, g, b;
	r = (BYTE)(get_red  (*this) * rate/255);	// red
	g = (BYTE)(get_green(*this) * rate/255);	// green
	b = (BYTE)(get_blue (*this) * rate/255);	// blue

	*d_pix.m_pbits = d_pix.m_p_col_table->get_col_index<8>(r, g, b);
}
// n bit <- 16bit ijuhȂ
template <int bit> inline void PIXEL_ITR_BASE<bit>::to_no_blend_draw(PIXEL_ITR_BASE<16> &d_pix, int rate){
		WORD *pw=(WORD*)d_pix.m_pbits;	// blue 8bit -> 5bit
		*pw = ((((get_red(*this)  >>3)* rate/255)<<10) )
			| ((((get_green(*this)>>3)* rate/255)<<5) )
			| (  (get_blue(*this) >>3)* rate/255);
}
// n bit <- 24bit ijuhȂ
template <int bit> inline void PIXEL_ITR_BASE<bit>::to_no_blend_draw(PIXEL_ITR_BASE<24> &d_pix, int rate){
		d_pix.m_pbits[0]=get_blue(*this) * rate/255 ;
		d_pix.m_pbits[1]=get_green(*this)* rate/255 ;
		d_pix.m_pbits[2]=get_red(*this)  * rate/255 ;
}
// n bit <- 32bit ijuhȂ
template <int bit> inline void PIXEL_ITR_BASE<bit>::to_no_blend_draw(PIXEL_ITR_BASE<32> &d_pix, int rate){
		d_pix.m_pbits[0]=get_blue(*this)  * rate/255 ;
		d_pix.m_pbits[1]=get_green(*this) * rate/255 ;
		d_pix.m_pbits[2]=get_red(*this)   * rate/255 ;
}

//==========PIXEL_ITR_BASE `Rs[ijuh=========================================
// 1 bit <- n bit ijuh
template <int bit> inline void PIXEL_ITR_BASE<bit>::to_blend_draw(PIXEL_ITR_BASE<1> &d_pix, int rate){
	BYTE r, g, b;
	r=get_blue (*this)* rate/255 + get_red  (d_pix)* (255-rate)/255;
	g=get_green(*this)* rate/255 + get_green(d_pix)* (255-rate)/255;
	b=get_red  (*this)* rate/255 + get_blue (d_pix)* (255-rate)/255;

	*d_pix.m_pbits = d_pix.m_p_col_table->get_col_index<1>(r, g, b);
}
// 4 bit <- n bit ijuh
template <int bit> inline void PIXEL_ITR_BASE<bit>::to_blend_draw(PIXEL_ITR_BASE<4> &d_pix, int rate){
	BYTE r, g, b;
	r=get_blue (*this)* rate/255 + get_red  (d_pix)* (255-rate)/255;
	g=get_green(*this)* rate/255 + get_green(d_pix)* (255-rate)/255;
	b=get_red  (*this)* rate/255 + get_blue (d_pix)* (255-rate)/255;

	*d_pix.m_pbits = d_pix.m_p_col_table->get_col_index<4>(r, g, b);
}
// 8 bit <- n bit ijuh
template <int bit> inline void PIXEL_ITR_BASE<bit>::to_blend_draw(PIXEL_ITR_BASE<8> &d_pix, int rate){
	BYTE r, g, b;
	r=get_blue (*this)* rate/255 + get_red  (d_pix)* (255-rate)/255;
	g=get_green(*this)* rate/255 + get_green(d_pix)* (255-rate)/255;
	b=get_red  (*this)* rate/255 + get_blue (d_pix)* (255-rate)/255;

	*d_pix.m_pbits = d_pix.m_p_col_table->get_col_index<8>(r, g, b);
}
// 16 bit <- n bit ijuh
template <int bit> inline void PIXEL_ITR_BASE<bit>::to_blend_draw(PIXEL_ITR_BASE<16> &d_pix, int rate){
		WORD *pw=(WORD*)d_pix.m_pbits;	// blue 8bit -> 5bit
		*pw =( ((((get_red  (*this)>>3)* rate/255)<<10))+ (((get_red  (d_pix)>>3)* (255-rate)/255)<<10) )
			|( ((((get_green(*this)>>3)* rate/255)<<5) )+ (((get_green(d_pix)>>3)* (255-rate)/255)<<5)  )
			| (   (get_blue (*this)>>3)* rate/255)      +  ((get_blue (d_pix)>>3)* (255-rate)/255);
}
// 24 bit <- n bit ijuh
template <int bit> inline void PIXEL_ITR_BASE<bit>::to_blend_draw(PIXEL_ITR_BASE<24> &d_pix, int rate){
		d_pix.m_pbits[0]=get_blue(*this) * rate/255 + d_pix.m_pbits[0]* (255-rate)/255;
		d_pix.m_pbits[1]=get_green(*this)* rate/255 + d_pix.m_pbits[1]* (255-rate)/255;
		d_pix.m_pbits[2]=get_red(*this)	 * rate/255 + d_pix.m_pbits[2]* (255-rate)/255;
}
// 32 bit <- n bit ijuh
template <int bit> inline void PIXEL_ITR_BASE<bit>::to_blend_draw(PIXEL_ITR_BASE<32> &d_pix, int rate){
		d_pix.m_pbits[0]=get_blue(*this) * rate/255 + d_pix.m_pbits[0]* (255-rate)/255;
		d_pix.m_pbits[1]=get_green(*this)* rate/255 + d_pix.m_pbits[1]* (255-rate)/255;
		d_pix.m_pbits[2]=get_red(*this)  * rate/255 + d_pix.m_pbits[2]* (255-rate)/255;
}
//==========PIXEL_ITR_BASE `Rs[ij=========================================
// 1 bit <- n bit 
template <int bit> inline void PIXEL_ITR_BASE<bit>::to_draw(PIXEL_ITR_BASE<1> &d_pix){
	BYTE col_index = d_pix.m_p_col_table->get_col_index<1>(get_red(*this), get_green(*this), get_blue(*this));
	*d_pix.m_pbits = ((1 & col_index) << (7-d_pix.m_bit_pos))
					| (*d_pix.m_pbits & ~(BYTE)(1 << (7-d_pix.m_bit_pos))) ;
}
// 4 bit <- n bit 
template <int bit> inline void PIXEL_ITR_BASE<bit>::to_draw(PIXEL_ITR_BASE<4> &d_pix){
	BYTE col_index = d_pix.m_p_col_table->get_col_index<4>(get_red(*this), get_green(*this), get_blue(*this));
	*d_pix.m_pbits = (col_index << (4-d_pix.m_bit_pos)) | (*d_pix.m_pbits & (0x0f << d_pix.m_bit_pos));
}
// 8 bit <- n bit 
template <int bit> inline void PIXEL_ITR_BASE<bit>::to_draw(PIXEL_ITR_BASE<8> &d_pix){
	*d_pix.m_pbits = d_pix.m_p_col_table->get_col_index<8>(get_red(*this), get_green(*this), get_blue(*this));
}
// 16 bit <- n bit 
template <int bit> inline void PIXEL_ITR_BASE<bit>::to_draw(PIXEL_ITR_BASE<16> &d_pix){
		WORD *pw=(WORD*)(d_pix.m_pbits);	// blue 8bit -> 5bit
		*pw = (((get_red(*this) >>3)<<10) )
			| (((get_green(*this)>>3)<<5)  )
			|   (get_blue(*this)  >>3);
}
// 24 bit <- n bit 
template <int bit> inline void PIXEL_ITR_BASE<bit>::to_draw(PIXEL_ITR_BASE<24> &d_pix){
		d_pix.m_pbits[0]=get_blue(*this);
		d_pix.m_pbits[1]=get_green(*this);
		d_pix.m_pbits[2]=get_red(*this);
}
// 32 bit <- n bit 
template <int bit> inline void PIXEL_ITR_BASE<bit>::to_draw(PIXEL_ITR_BASE<32> &d_pix){
		d_pix.m_pbits[0]=get_blue(*this);
		d_pix.m_pbits[1]=get_green(*this);
		d_pix.m_pbits[2]=get_red(*this);
		d_pix.m_pbits[3]=0;
}

// ====== sNZECe[^iAt@lj ========================
template <int alpha> 
class PIXEL_ALPHA_ITR {
	public:
	int m_width, m_height;
	BYTE *m_palpha, *m_start_palpha;
	set_pos(int x, int y){
	}
	init(char *start_palpha, int img_width, int img_height){
		m_start_palpha = start_palpha;
		m_width = img_width;
		m_height = img_height;
	}
	static increment(PIXEL_ALPHA_ITR<0> &alpha_itr){};
	static increment(PIXEL_ALPHA_ITR<1> &alpha_itr){ alpha_itr.m_palpha++; };
	static decrement(PIXEL_ALPHA_ITR<0> &alpha_itr){};
	static decrement(PIXEL_ALPHA_ITR<1> &alpha_itr){ alpha_itr.m_palpha--; };
	static rate_calc(PIXEL_ALPHA_ITR<0> &alpha_itr, int &rate){};
	static rate_calc(PIXEL_ALPHA_ITR<1> &alpha_itr, int &rate){ rate=alpha_itr.m_palpha[0]*rate/255; };
};

// ====== sNZECe[^ ========================
template <int bit, int alpha> 
class PIXEL_ITR : public PIXEL_ITR_BASE<bit>, public PIXEL_ALPHA_ITR<alpha> {
	public:
	set_pos(int x, int y){
		PIXEL_ITR_BASE<bit>::set_pos(x, y);
		PIXEL_ALPHA_ITR<alpha>::set_pos(x, y);
	};
	init(char *start_pbits, char *start_palpha, int img_byte_width, int img_width, int img_height, GT_COL_TABLE *p_col_table){
		PIXEL_ITR_BASE<bit>::init(start_pbits, img_byte_width, img_height, p_col_table);
		PIXEL_ALPHA_ITR<alpha>::init(start_palpha, img_width, img_height);
	};
	void operator ++(){
		PIXEL_ITR_BASE<bit>::increment(*this);
		PIXEL_ALPHA_ITR<alpha>::increment(*this);
	};
	void operator +=(int dx){ add(*this, dx); };

	BYTE get_index(){ PIXEL_ITR_BASE<bit>::get_index(*this); }
	void set_col(BYTE col_index){ PIXEL_ITR_BASE<bit>::set_col_by_index(*this, col_index); };
	void set_col(BYTE r, BYTE g, BYTE b, int rate){ PIXEL_ITR_BASE<bit>::set_col(*this, r, g, b, rate); };
	void set_col_no_blend(BYTE r, BYTE g, BYTE b, int rate){ PIXEL_ITR_BASE<bit>::set_col_no_blend(*this, r, g, b, rate); };
};

#endif // _GT_IMG_PARTS_H_

